clear;
clc;
tic;
close all;

x_length = 300;
y_length = 300;

II = importdata('4_900ms_4mV_300x300.txt');

[N,NN]=size(II);


for i=1:N
    III=reshape(II(i,:),y_length,x_length);
    Pixel(i,:,:) = III(:,:);                                %165 148
end



III1=reshape(II(5,:),y_length,x_length);   

IIII=reshape(II(191,:),y_length,x_length);
figure();
imagesc(IIII);
caxis([0,255]);
set(gcf,'Position',[200 200 280 200]);
colorbar;

Waveform = (IIII - III1)./III1.^0.85;
figure();
imagesc(Waveform/max(max(Waveform(150:200,150:200))));
set(gcf,'Position',[200 200 400 400]);

% figure();
% imagesc(Waveform/max(max(Waveform(150:200,150:200))));
% set(gcf,'Position',[200 200 280 200]);
% colorbar;
% figure();
% imagesc((Waveform/max(max(Waveform(150:200,150:200)))).^2);
% set(gcf,'Position',[200 200 480 400]);
% colorbar;


figure();
Ds = 0.926e-15;
c=299792458;
x_center = 158;
y_center = 161;
plot(Pixel(100:350,158,161),'b','linewidth',2);

for ii=158                              %158
    for jj=161                           %161
        Mod = (Pixel(100:350,ii,jj))';                     %100-350 range is also important
        Sign(ii,jj) = sign(Mod(86)-Mod(92));
%         hold on
%         plot(Mod,'r','linewidth',1.2);
for j=1:10*length(Mod)
    delay_int3(j)=0+(Ds)*(j-1);
end
I_mod_int3(1:length(Mod))=Mod;
I_mod_int3(length(Mod)+1:10*length(Mod))=Mod(length(Mod));

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);

freq_ret=linspace(-1/2/(Ds),(N/2-1)/N/(Ds),N);
phase_ret=atan(imag(I_spec)./real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3425)==min(abs(3e8./freq_ret*1e9-3425)));       %Wavelength 3.6 um important
wavelength_ret_3400=freq_ret(ff);


figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2400,4200]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum_center(:,1)=3e8./freq_ret(dd:bb)*1e9;
Spectrum_center(:,2)=(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);
dlmwrite('Spectrum_center.txt',Spectrum_center,'delimiter','\t','precision',7);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

Phase_3400(ii,jj) = phase_ret(ff)+freq_ret(ff)*0.54e-12-140+119.2;

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*0.54e-12-140+119.2,'r','linewidth',1.2);
xlim([2400,4000]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);



    end
end

for ii=1:300                              %158
    for jj=1:300                           %161
        Mod = (Pixel(100:350,ii,jj))';                     %100-350 range is also important
        Sign(ii,jj) = sign(Mod(86)-Mod(92));
%         hold on
%         plot(Mod,'r','linewidth',1.2);
for j=1:10*length(Mod)
    delay_int3(j)=0+(Ds)*(j-1);
end
I_mod_int3(1:length(Mod))=Mod;
I_mod_int3(length(Mod)+1:10*length(Mod))=Mod(length(Mod));

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);

freq_ret=linspace(-1/2/(Ds),(N/2-1)/N/(Ds),N);
phase_ret=atan(imag(I_spec)./real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3425)==min(abs(3e8./freq_ret*1e9-3425)));       %Wavelength 3.6 um important
wavelength_ret_3400=freq_ret(ff);


% figure();
% plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
% xlim([2400,4200]);
% ylim([0,1.05]);
% xlabel('Wavelength (nm)');
% ylabel('Normalized Intensity');
% set(gca,'fontsize',20);

Spectrum_center(:,1)=3e8./freq_ret(dd:bb)*1e9;
Spectrum_center(:,2)=(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);
dlmwrite('Spectrum_center.txt',Spectrum_center,'delimiter','\t','precision',7);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

Phase_3400(ii,jj) = phase_ret(ff)+freq_ret(ff)*0.54e-12-140+119.2;

% figure();
% plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*0.54e-12-140+119.2,'r','linewidth',1.2);
% xlim([2400,4000]);
% % ylim([-10,10]);
% xlabel('Wavelength (nm)');
% ylabel('Phase (rad)');
% set(gca,'fontsize',20);



    end
end

figure();
plot(Phase_3400(158,:));
Phase_3400_2 = (Phase_3400/2/pi - floor(Phase_3400/2/pi))*2*pi-3.25;
figure();
plot(Phase_3400_2(158,:));

% figure();
% imagesc(Phase_3400_2(138:178,141:181));

Phase_3400_3 = (Phase_3400_2/pi - floor(Phase_3400_2/pi))*pi;
figure();
plot(Phase_3400_3(158,:));


Phase_3400_4 = Phase_3400_3+(Sign-1)/2*pi;
figure();
plot(Phase_3400_4(158,:));

figure();
imagesc(Phase_3400_4);

dlmwrite('Phase_3425.txt',Phase_3400,'delimiter','\t','precision',7);
dlmwrite('Phase_3425_4.txt',Phase_3400_4,'delimiter','\t','precision',7);


















toc;