clear;
clc;
tic;
close all;

Wavelength_P = importdata('Wavelength_P.txt');
Wavelength_S = importdata('Wavelength_S.txt');

II_S1 = importdata('Phase_S.txt');
for i=1:54
    III=reshape(II_S1(i,:),140,140);
    II_S2(i,:,:) = III(:,:);                                %165 148
end
II_S(:,:) = sum(II_S2(26:29,:,:))/4;
II_S(:,:) = II_S2(27,:,:);
figure();
imagesc(II_S);


II_P1 = importdata('Phase_P.txt');
for i=1:54
    III=reshape(II_P1(i,:),140,140);
    II_P2(i,:,:) = III(:,:);                                %165 148
end
II_P(:,:) = sum(II_P2(26:29,:,:))/4;
II_P(:,:) = II_P2(27,:,:);
figure();
imagesc(II_P);
figure();
imagesc(II_S-II_P);
hold on
X = [42 102];
Y = [50 50];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 102];
Y = [105 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 42];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [102 102];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);

hold on

rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
axis equal;

xlim([0,140]);
ylim([0,140]);
set(gca,'fontsize',20);
colorbar;





delta = -(II_S-II_P);

II_Sint = importdata('Intensity_S.txt');
figure();
imagesc(II_Sint);

II_Pint = importdata('Intensity_P.txt');
figure();
imagesc(II_Pint);

II_sgnS = importdata('Sgn_S.txt');
II_sgnP = importdata('Sgn_P.txt');
figure();
imagesc(atan2(-II_Sint.*II_sgnS,-II_Pint.*II_sgnP));
hold on
X = [42 102];
Y = [50 50];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 102];
Y = [105 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 42];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [102 102];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);


hold on

rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
axis equal;

xlim([0,140]);
ylim([0,140]);
set(gca,'fontsize',20);
colorbar;

% 
% xx=([0:1:139])*5.86e-3;
% yy=([139:-1:0])*5.86e-3;
% [X,Y]=meshgrid(xx,yy);
% figure;
% pcolor(X,Y,atan2(-II_Sint.*II_sgnS,-II_Pint.*II_sgnP));
% % xlim([0.2,1.4]);
% % ylim([0.2,1.4]);
% colorbar;
% shading interp
% xlabel('x Position (mm)');
% ylabel('y Position (mm)');
% set(gca,'fontsize',20);

xx=([0:1:139])*5.86e-3-0.43;
yy=([139:-1:0])*5.86e-3-0.35;
[X,Y]=meshgrid(xx,yy);
figure;
pcolor(X,Y,atan2(-II_Sint.*II_sgnS,-II_Pint.*II_sgnP));
% xlim([0.2,1.4]);
% ylim([0.2,1.4]);

hold on
X = [0.25 0.58]-0.43;
Y = [0.52 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.58]-0.43;
Y = [0.20 0.20]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.25]-0.43;
Y = [0.20 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.58 0.58]-0.43;
Y = [0.2 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on

rectangle('Position',[0.43-0.03-0.43,0.35-0.03-0.35,0.03*2,0.03*2],'curvature',[1,1]);
axis equal;
colorbar;
shading interp
xlabel('x Position (mm)');
ylabel('y Position (mm)');
set(gca,'fontsize',20);

Polarization(1,1)=0;
Polarization(1,2:length(xx)+1)=xx;
Polarization(2:length(yy)+1,1)=yy';
Polarization(2:length(yy)+1,2:length(xx)+1)=atan2(-II_Sint.*II_sgnS,-II_Pint.*II_sgnP);
dlmwrite('Polarization.txt',Polarization,'delimiter','\t','precision',7);




E_total = (II_Sint + II_Pint).^0.5;
E_max = max(max(E_total));
E_total = E_total/max(max(E_total));
figure();
imagesc(E_total);

figure();
imagesc(E_total.^2);
xlabel('Pixel');
ylabel('Pixel');
set(gca,'fontsize',16);
hold on
X = [42 102];
Y = [50 50];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 102];
Y = [105 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 42];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [102 102];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);

hold on

rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
axis equal;

xlim([0,140]);
ylim([0,140]);
set(gca,'fontsize',20);
colorbar;







xx=([0:1:139])*5.86e-3-0.43;
yy=([139:-1:0])*5.86e-3-0.35;
[X,Y]=meshgrid(xx,yy);
figure;
pcolor(X,Y,E_total.^2);
% xlim([0.2,1.4]);
% ylim([0.2,1.4]);

shading interp
xlabel('x Position (mm)');
ylabel('y Position (mm)');
set(gca,'fontsize',20);

hold on
X = [0.25 0.58]-0.43;
Y = [0.52 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.58]-0.43;
Y = [0.20 0.20]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.25]-0.43;
Y = [0.20 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.58 0.58]-0.43;
Y = [0.2 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on

rectangle('Position',[0.43-0.03-0.43,0.35-0.03-0.35,0.03*2,0.03*2],'curvature',[1,1]);
axis equal;

% xlim([0,0.801]);
% ylim([0,0.801]);
set(gca,'fontsize',20);
colorbar;





TIPTOE_Bessel(1,1)=0;
TIPTOE_Bessel(1,2:length(xx)+1)=xx;
TIPTOE_Bessel(2:length(yy)+1,1)=yy';
TIPTOE_Bessel(2:length(yy)+1,2:length(xx)+1)=E_total.^2;
dlmwrite('TIPTOE_Vector.txt',TIPTOE_Bessel,'delimiter','\t','precision',7);




B = II_Sint.^0.5/E_max;
A = II_Pint.^0.5/E_max;

% delta(:,:)=1;

alfa = 0.5*atan2(2*A.*B.*cos(delta),(A.^2-B.^2));
figure();
imagesc(alfa);

hold on
X = [42 102];
Y = [50 50];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 102];
Y = [105 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 42];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [102 102];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);

hold on

rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
axis equal;

xlim([0,140]);
ylim([0,140]);
set(gca,'fontsize',20);
colorbar;

E_a_max = (A.^2+B.^2).^0.5.*(A.^2.*(cos(alfa)).^2+B.^2.*(sin(alfa)).^2+A.*B.*cos(delta).*sin(2*alfa)).^0.5;
figure();
imagesc(E_a_max);
E_a_min = (A.^2+B.^2).^0.5.*(A.^2.*(sin(alfa)).^2+B.^2.*(cos(alfa)).^2-A.*B.*cos(delta).*sin(2*alfa)).^0.5;
figure();
imagesc(E_a_min);

E_ellipticity = E_a_min./E_a_max;
% E_ellipticity = E_a_max./E_a_min;

figure();
imagesc(E_ellipticity);
caxis([0,1]);
xlabel('Pixel');
ylabel('Pixel');
set(gca,'fontsize',16);


hold on
X = [42 102];
Y = [50 50];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 102];
Y = [105 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 42];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [102 102];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);


hold on

rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
axis equal;

xlim([0,140]);
ylim([0,140]);
set(gca,'fontsize',20);
colorbar;




xx=([0:1:139])*5.86e-3-0.43;
yy=([139:-1:0])*5.86e-3-0.35;
[X,Y]=meshgrid(xx,yy);
figure;
pcolor(X,Y,E_ellipticity);
% xlim([0.2,1.4]);
% ylim([0.2,1.4]);

shading interp
xlabel('x Position (mm)');
ylabel('y Position (mm)');
set(gca,'fontsize',20);

hold on
X = [0.25 0.58]-0.43;
Y = [0.52 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.58]-0.43;
Y = [0.20 0.20]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.25]-0.43;
Y = [0.20 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.58 0.58]-0.43;
Y = [0.2 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on

rectangle('Position',[0.43-0.03-0.43,0.35-0.03-0.35,0.03*2,0.03*2],'curvature',[1,1]);
axis equal;

xlim([-0.3,0.3]);
ylim([-0.3,0.3]);
set(gca,'fontsize',20);
colorbar;

Ellipticity(1,1)=0;
Ellipticity(1,2:length(xx)+1)=xx;
Ellipticity(2:length(yy)+1,1)=yy';
Ellipticity(2:length(yy)+1,2:length(xx)+1)=E_ellipticity;
dlmwrite('Ellipticity.txt',Ellipticity,'delimiter','\t','precision',7);





figure();
imagesc(E_ellipticity);
caxis([0,0.3]);
xlabel('Pixel');
ylabel('Pixel');
set(gca,'fontsize',16);


hold on
X = [42 102];
Y = [50 50];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 102];
Y = [105 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 42];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [102 102];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);


hold on

rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
axis equal;

xlim([0,140]);
ylim([0,140]);
set(gca,'fontsize',20);
colorbar;


figure();
imagesc(E_ellipticity);
caxis([0,0.1]);
xlabel('Pixel');
ylabel('Pixel');
set(gca,'fontsize',16);


hold on
X = [42 102];
Y = [50 50];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 102];
Y = [105 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [42 42];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [102 102];
Y = [50 105];
plot(X,Y,'k--','linewidth',1.2);


hold on

rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
axis equal;

xlim([0,140]);
ylim([0,140]);
set(gca,'fontsize',20);
colorbar;

Int_Boson1 = importdata('RadiallyBeam_13.jpeg');
Int_Boson2 = importdata('RadiallyBeam_17.jpeg');
Int_MIR = double(Int_Boson1-Int_Boson2);
figure();
imagesc((Int_MIR(273-68:273+68,315-68:315+68,1))/max(max(Int_MIR(273-68:273+68,315-68:315+68,1))));
xlabel('Pixel');
ylabel('Pixel');
set(gca,'fontsize',16);


% xxx=([0:1:136])*6e-3-0.058;
% yyy=([136:-1:0])*6e-3-0.03;
xxx=([0:1:136])*6e-3+0.02-0.43;
yyy=([136:-1:0])*6e-3-0.002-0.35;
[X,Y]=meshgrid(xxx,yyy);
figure;
pcolor(X,Y,(Int_MIR(273-68:273+68,315-68:315+68,1))/max(max(Int_MIR(273-68:273+68,315-68:315+68,1))));
% xlim([0,0.7]);
% ylim([0,0.7]);

shading interp
xlabel('x Position (mm)');
ylabel('y Position (mm)');
set(gca,'fontsize',20);


hold on
X = [0.25 0.58]-0.43;
Y = [0.52 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.58]-0.43;
Y = [0.20 0.20]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.25]-0.43;
Y = [0.20 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.58 0.58]-0.43;
Y = [0.2 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on

rectangle('Position',[0.43-0.03-0.43,0.35-0.03-0.35,0.03*2,0.03*2],'curvature',[1,1]);
axis equal;

% xlim([0,0.801]);
% ylim([0,0.801]);
set(gca,'fontsize',20);
colorbar;

Boson_Vector(1,1)=0;
Boson_Vector(1,2:length(xxx)+1)=xxx;
Boson_Vector(2:length(yyy)+1,1)=yyy';
Boson_Vector(2:length(yyy)+1,2:length(xxx)+1)=(Int_MIR(273-68:273+68,315-68:315+68,1))/max(max(Int_MIR(273-68:273+68,315-68:315+68,1)));
dlmwrite('Boson_Vector.txt',Boson_Vector,'delimiter','\t','precision',7);
% axis equal;


%Dodge 1984
lambda = linspace(0.2,7.0,100000);
n_o = (1+0.48755108*lambda.^2./(lambda.^2-0.04338408^2)+0.39875031*lambda.^2./(lambda.^2-0.09461442^2)+2.3120353*lambda.^2./(lambda.^2-23.793604^2)).^0.5;
figure();
plot(lambda,n_o,'r','linewidth',1.2);


n_e = (1+0.41344023*lambda.^2./(lambda.^2-0.03684262^2)+0.50497499*lambda.^2./(lambda.^2-0.09076162^2)+2.4904862*lambda.^2./(lambda.^2-23.771995^2)).^0.5;
hold on
plot(lambda,n_e,'b','linewidth',1.2);
legend('n_o','n_e');
xlim([0,7]);
xlabel('Wavelength (um)');
ylabel('Refractive Index');
set(gca,'fontsize',20);

lambda0 = 3.28;
[aa,bb] = find(abs(lambda-lambda0)==min(abs(lambda-lambda0)));
n0_1 = n_o(bb);
n0_2 = n_e(bb);
Thickness = pi*lambda0*1e-6/2/pi/(n0_2-n0_1); 


c = 299792458;

lambda_wavelength = linspace(2.6,4,1000);
for ii =1:length(lambda_wavelength)
    [aa,bb] = find(abs(lambda-lambda_wavelength(ii))==min(abs(lambda-lambda_wavelength(ii))));
    n_o1 = n_o(bb);
    n_e1 = n_e(bb);
    Phase_difference(ii) = (Thickness/c*n_e1 -Thickness/c*n_o1)/(lambda_wavelength(ii)*1e-6/c)*2*pi;
end

% figure();
% plot(lambda_wavelength,Phase_difference,'r','linewidth',1.2);
% Phase = linspace(pi,pi,length(lambda_wavelength));
% hold on
% plot(lambda_wavelength,Phase,'b--','linewidth',1.2);
% xlabel('Wavelength (um)');
% ylabel('Phase retardation (rad)');
% legend('Phase difference between o and e (rad)','Phase difference pi at 3.28 um, HWP');
% set(gca,'fontsize',20);


figure();
plot(lambda_wavelength,Phase_difference,'r','linewidth',1.2);

Phase_wave = II_P2(:,:,:)-II_S2(:,:,:);
% Phase_wave(13:22,:,:)=Phase_wave(13:22,:,:)+2*pi;
% Phase_wave(34:41,:,:)=Phase_wave(34:41,:,:)+2*pi;




aa=95;
bb=85;


for ii=1:53
    if II_P2(ii,aa,bb)<II_P2(ii+1,aa,bb)
        II_P2(ii+1,aa,bb)=II_P2(ii+1,aa,bb)-2*pi;
    end
end

for ii=1:53
    if II_P2(ii,aa,bb)<II_P2(ii+1,aa,bb)
        II_P2(ii+1,aa,bb)=II_P2(ii+1,aa,bb)-2*pi;
    end
end

for ii=1:53
    if II_S2(ii,aa,bb)<II_S2(ii+1,aa,bb)
        II_S2(ii+1,aa,bb)=II_S2(ii+1,aa,bb)-2*pi;
    end
end

for ii=1:53
    if II_S2(ii,aa,bb)<II_S2(ii+1,aa,bb)
        II_S2(ii+1,aa,bb)=II_S2(ii+1,aa,bb)-2*pi;
    end
end


aaa=95;
bbb=85;


for aa = aaa
    
    for bb = bbb
hold on
plot(Wavelength_P*1e6,II_S2(:,aa,bb)-II_P2(:,aa,bb)+2*pi,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_S2(:,aa,bb),'b','linewidth',1.2);
    end
end
% ylim([2,4]);
% xlim([3,3.6]);        %wavelength range 3.1 - 3.5


% 
% figure();
% plot(II_P2(:,aa,bb));

% for ii=1:53
%     if II_P2(ii,aa,bb)<II_P2(ii+1,aa,bb)
%         II_P2(ii+1,aa,bb)=II_P2(ii+1,aa,bb)-2*pi;
%     end
% end
% 
% for ii=1:53
%     if II_P2(ii,aa,bb)<II_P2(ii+1,aa,bb)
%         II_P2(ii+1,aa,bb)=II_P2(ii+1,aa,bb)-2*pi;
%     end
% end
% 
% for ii=1:53
%     if II_S2(ii,aa,bb)<II_S2(ii+1,aa,bb)
%         II_S2(ii+1,aa,bb)=II_S2(ii+1,aa,bb)-2*pi;
%     end
% end
% 
% for ii=1:53
%     if II_S2(ii,aa,bb)<II_S2(ii+1,aa,bb)
%         II_S2(ii+1,aa,bb)=II_S2(ii+1,aa,bb)-2*pi;
%     end
% end
%         
% figure();
% plot(II_P2(:,aa,bb),'r');
% hold on
% plot(II_S2(:,aa,bb),'b');













% close all

% II_S = importdata('Phase_S_3200.txt');
% 
% figure();
% imagesc(II_S);
% 
% 
% II_P = importdata('Phase_P_3200.txt');
% 
% figure();
% imagesc(II_P);
% 
% figure();
% imagesc(II_S-II_P);
% 
% delta = -(II_S-II_P);
% 
% II_Sint = importdata('Intensity_S.txt');
% figure();
% imagesc(II_Sint);
% 
% II_Pint = importdata('Intensity_P.txt');
% figure();
% imagesc(II_Pint);
% 
% E_total = (II_Sint + II_Pint).^0.5;
% E_max = max(max(E_total));
% E_total = E_total/max(max(E_total));
% figure();
% imagesc(E_total);
% figure();
% imagesc(E_total.^2);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% 
% B = II_Sint.^0.5/E_max;
% A = II_Pint.^0.5/E_max;
% 
% % delta(:,:)=1;
% 
% alfa = 0.5*atan2(2*A.*B.*cos(delta),(A.^2-B.^2));
% figure();
% imagesc(alfa);
% 
% E_a_max = (A.^2+B.^2).^0.5.*(A.^2.*(cos(alfa)).^2+B.^2.*(sin(alfa)).^2+A.*B.*cos(delta).*sin(2*alfa)).^0.5;
% figure();
% imagesc(E_a_max);
% E_a_min = (A.^2+B.^2).^0.5.*(A.^2.*(sin(alfa)).^2+B.^2.*(cos(alfa)).^2-A.*B.*cos(delta).*sin(2*alfa)).^0.5;
% figure();
% imagesc(E_a_min);
% 
% E_ellipticity = E_a_min./E_a_max;
% % E_ellipticity = E_a_max./E_a_min;
% figure();
% imagesc(E_ellipticity);
% caxis([0,1]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% figure();
% imagesc(E_ellipticity);
% caxis([0,0.3]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% 
% 
% delta(:,:)=0.0000001;
% 
% alfa = 0.5*atan2(2*A.*B.*cos(delta),(A.^2-B.^2));
% figure();
% imagesc(alfa);
% 
% E_a_max = (A.^2+B.^2).^0.5.*(A.^2.*(cos(alfa)).^2+B.^2.*(sin(alfa)).^2+A.*B.*cos(delta).*sin(2*alfa)).^0.5;
% figure();
% imagesc(E_a_max);
% E_a_min = (A.^2+B.^2).^0.5.*(A.^2.*(sin(alfa)).^2+B.^2.*(cos(alfa)).^2-A.*B.*cos(delta).*sin(2*alfa)).^0.5;
% figure();
% imagesc(E_a_min);
% 
% E_ellipticity = E_a_min./E_a_max;
% % E_ellipticity = E_a_max./E_a_min;
% figure();
% imagesc(E_ellipticity);
% caxis([0,1]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% figure();
% imagesc(E_ellipticity);
% caxis([0,0.01]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);

% % close all;
% 
% II_S = importdata('Phase_S_3260.txt');
% 
% figure();
% imagesc(II_S);
% 
% 
% II_P = importdata('Phase_P_3260.txt');
% 
% figure();
% imagesc(II_P);
% 
% figure();
% imagesc(II_S-II_P);
% 
% delta = -(II_S-II_P);
% 
% II_Sint = importdata('Intensity_S.txt');
% figure();
% imagesc(II_Sint);
% 
% II_Pint = importdata('Intensity_P.txt');
% figure();
% imagesc(II_Pint);
% 
% E_total = (II_Sint + II_Pint).^0.5;
% E_max = max(max(E_total));
% E_total = E_total/max(max(E_total));
% figure();
% imagesc(E_total);
% figure();
% imagesc(E_total.^2);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% 
% B = II_Sint.^0.5/E_max;
% A = II_Pint.^0.5/E_max;
% 
% % delta(:,:)=1;
% 
% alfa = 0.5*atan2(2*A.*B.*cos(delta),(A.^2-B.^2));
% figure();
% imagesc(alfa);
% 
% E_a_max = (A.^2+B.^2).^0.5.*(A.^2.*(cos(alfa)).^2+B.^2.*(sin(alfa)).^2+A.*B.*cos(delta).*sin(2*alfa)).^0.5;
% figure();
% imagesc(E_a_max);
% E_a_min = (A.^2+B.^2).^0.5.*(A.^2.*(sin(alfa)).^2+B.^2.*(cos(alfa)).^2-A.*B.*cos(delta).*sin(2*alfa)).^0.5;
% figure();
% imagesc(E_a_min);
% 
% E_ellipticity = E_a_min./E_a_max;
% % E_ellipticity = E_a_max./E_a_min;
% figure();
% imagesc(E_ellipticity);
% caxis([0,1]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% figure();
% imagesc(E_ellipticity);
% caxis([0,0.3]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);


% delta(:,:)=0.0000001;
% 
% alfa = 0.5*atan2(2*A.*B.*cos(delta),(A.^2-B.^2));
% figure();
% imagesc(alfa);
% 
% E_a_max = (A.^2+B.^2).^0.5.*(A.^2.*(cos(alfa)).^2+B.^2.*(sin(alfa)).^2+A.*B.*cos(delta).*sin(2*alfa)).^0.5;
% figure();
% imagesc(E_a_max);
% E_a_min = (A.^2+B.^2).^0.5.*(A.^2.*(sin(alfa)).^2+B.^2.*(cos(alfa)).^2-A.*B.*cos(delta).*sin(2*alfa)).^0.5;
% figure();
% imagesc(E_a_min);
% 
% E_ellipticity = E_a_min./E_a_max;
% % E_ellipticity = E_a_max./E_a_min;
% figure();
% imagesc(E_ellipticity);
% caxis([0,1]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% figure();
% imagesc(E_ellipticity);
% caxis([0,0.01]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);


















% Phase_S = (II/2/pi - floor(II/2/pi))*2*pi;
% figure();
% imagesc(Phase_S);

% II_delay = importdata('Delay.txt');
% delay = II_delay(8:1001)*1e-15;
% 
% II=importdata('19_FundamentalLoop_2mV_140x140.txt');
% x_length = 140;
% y_length = 140;
% [N,NN]=size(II);
% 
% N=1001;
% % delay_int=linspace(min(delay),max(delay),length(delay));
% for i=8:N
%     III=reshape(II(i,:),y_length,x_length);
%     Pixel(i,:,:) = III(:,:);                                %165 148
% end
% 
% 
% delay_int=linspace(min(delay),max(delay),length(delay));
% 
% [ee,ff]=find(abs(delay_int-(260e-15))==min(abs(delay_int-(260e-15))));
% [gg,hh]=find(abs(delay_int-(265.5e-15))==min(abs(delay_int-(265.5e-15))));
% 
% Ds = delay_int(2)-delay_int(1);
% c=299792458;
% 
% xx=1:140;
% yy=1:140;
% 
% for ii=1:140
%     for jj=1:140
%         Mod = (Pixel(8:1001,ii,jj))';
%         I_mod_int_tt=interp1(delay,Mod,delay_int);
%         Sgn_S(ii,jj) = sign(I_mod_int_tt(ff)-I_mod_int_tt(hh));
%         I_mod_int = I_mod_int_tt(100:900);
% for j=1:10*length(I_mod_int)
%     delay_int3(j)=0+(Ds)*(j-1);
% end
% I_mod_int3(1:length(I_mod_int))=I_mod_int;
% I_mod_int3(length(I_mod_int)+1:10*length(I_mod_int))=I_mod_int(length(I_mod_int));
% 
% I_spec=fftshift(fft((I_mod_int3)));
% N=length(I_spec);
% 
% freq_ret=linspace(-1/2/(Ds),(N/2-1)/N/(Ds),N);
% phase_ret=atan(imag(I_spec)./real(I_spec));
% [aa,bb]=find(abs(freq_ret-c/2600e-9)==min(abs(freq_ret-c/2600e-9)));
% [cc,dd]=find(abs(freq_ret-c/4000e-9)==min(abs(freq_ret-c/4000e-9)));
% for j=dd:bb
%     for k=1:2000
%     if phase_ret(j)<phase_ret(j+1)
%         phase_ret(j+1)=phase_ret(j+1)-pi;
%     end
%     end
% end
% 
% % figure();
% % plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2-69,'r','linewidth',1.2);
% % xlim([2800,3800]);
% % % ylim([-10,10]);
% % xlabel('Wavelength (nm)');
% % ylabel('Phase (rad)');
% % set(gca,'fontsize',20);
% 
% [aaa,bbb]=find(abs(freq_ret-c/3284e-9)==min(abs(freq_ret-c/3284e-9)));
% Phase_S(ii,jj)=phase_ret(bbb)+freq_ret(bbb)*1.3e-12-140+117.6-69;
% % clear freq_ret3;
% % clear I_spec3;
% % %Modulation peak
% % 
% % freq_ret3=freq_ret(ceil(length(I_spec)/2)+1:length(I_spec));
% % [aa,bb]=find(abs(freq_ret3-c/2600e-9)==min(abs(freq_ret3-c/2600e-9)));
% % [cc,dd]=find(abs(freq_ret3-c/4000e-9)==min(abs(freq_ret3-c/4000e-9)));
% % 
% % 
% % 
% % I_spec2=I_spec(ceil(length(I_spec)/2)+1:length(I_spec));
% % I_spec3(1:length(freq_ret3))=0;
% % I_spec3(dd:bb)=I_spec2(dd:bb);
% % 
% % % figure();
% % % plot(3e8./freq_ret3(dd:bb)*1e9,(abs(I_spec3(dd:bb))).^2.*(freq_ret3(dd:bb)).^2/max((abs(I_spec3(dd:bb))).^2.*(freq_ret3(dd:bb)).^2),'r','linewidth',1.2);
% % % xlim([2800,3600]);
% % % ylim([0,1.05]);
% % % xlabel('Wavelength (nm)');
% % % ylabel('Normalized Intensity');
% % % set(gca,'fontsize',20);
% % E_ret2 = (fftshift(ifft((I_spec3))));
% % Modulation_peak = max(abs(E_ret2));
% % 
% % %Modulation bg
% % clear freq_ret3;
% % clear I_spec3;
% % freq_ret4=freq_ret;
% % I_spec4=I_spec;
% % E_ret4 = (fftshift(ifft((I_spec4))));
% % Modulation_retrieve = abs(E_ret4);
% % 
% % Modulation_bg = Modulation_retrieve(length(Modulation_retrieve));
% % 
% % Modulation_depth = Modulation_peak/Modulation_bg.^0.85;
% % Intensity_ret(ii,jj)=Modulation_depth^2;
% 
%     end
% end



% figure();
% imagesc(Sgn_S);

















toc;