clear;
clc;
tic;
close all;



II_delay = importdata('Delay16.txt');
delay = II_delay;
figure();
plot(II_delay,'b','linewidth',1.2);
hold on
plot(0.456*(1:1001),'r','linewidth',1.2); 
xlim([1,1001]);
xlabel('Steps');
ylabel('Delay (fs)');
set(gca,'fontsize',20);


II_mod = importdata('Pixel_59_64.txt');
Mod = II_mod(1200:1900);
Ds = 0.45e-15;
for j=1:10*length(Mod)
    delay_int3(j)=0+(Ds)*(j-1);
end
I_mod_int3(1:length(Mod))=Mod;
I_mod_int3(length(Mod)+1:10*length(Mod))=Mod(length(Mod));

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);

freq_ret=linspace(-1/2/(Ds),(N/2-1)/N/(Ds),N);
phase_ret=atan2(imag(I_spec),real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3282)==min(abs(3e8./freq_ret*1e9-3282)));
wavelength_ret_1500=freq_ret(dd);
% Phase_S = phase_ret(ff);

figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2800,3600]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum(:,3) = 3e8./freq_ret(dd:bb)*1e9;
Spectrum(:,4) = (abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);


for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end



figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2,'r','linewidth',1.2);
xlim([2800,3800]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);
Phase(:,3) = 3e8./freq_ret(dd:bb)*1e9;
Phase(:,4) = phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2;




II_delay = importdata('Delay16.txt');
% delay = II_delay;
% figure();
% plot(II_delay);

II_mod = importdata('Pixel_59_64.txt');

I_data = II_mod(10:1000);

delay=II_delay(10:1000)*1e-15;

figure();
plot(delay*1e15,I_data,'r','linewidth',1.2);
% delay_int=0.267e-15*(1:length(delay));
NN=length(delay);
% for ii=1:NN-1
%     if delay(ii+1)==delay(ii);
%         delay(ii+1)=delay(ii+1)*1.000001;
%     end
% end
delay_int=linspace(70e-15,400e-15,800);
I_mod_int_S=interp1(delay,I_data,delay_int);
% hold on
% plot(delay_int*1e15,I_mod_int,'b','linewidth',1.2);

% hold on
% plot(0.456*(100:900)-15,I_data,'k','linewidth',1.2);                 %Delay Calibration is necessary for MIR when using 2 meV voltage step, Without delay calibration, 4 meV is used.
xlabel('Delay (fs)');
ylabel('Modulation');
set(gca,'fontsize',20);


for j=1:10*length(delay_int)
    delay_int3(j)=delay_int(1)+(delay_int(2)-delay_int(1))*(j-1);
end
I_mod_int3(1:length(delay_int))=I_mod_int_S;
I_mod_int3(length(delay_int)+1:10*length(delay_int))=I_mod_int_S(length(I_mod_int_S));
figure();
plot(delay_int3*1e15,I_mod_int3,'b');
xlabel('Time (fs)');
ylabel('Intensity');

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);
freq_ret=linspace(-1/2/(delay_int(2)-delay_int(1)),(N/2-1)/N/(delay_int(2)-delay_int(1)),N);
phase_ret=atan2(imag(I_spec),real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3282)==min(abs(3e8./freq_ret*1e9-3282)));
wavelength_ret_1500=freq_ret(dd);
Phase_S = phase_ret(ff);

figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2800,3600]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum1(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Spectrum1(:,2) = (abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2,'r','linewidth',1.2);
xlim([2800,3800]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);

Phase1(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Phase1(:,2) = phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2;

I_data = II_mod(2000:-1:1010);

delay=II_delay(2000:-1:1010)*1e-15;

figure();
plot(delay*1e15,I_data,'r','linewidth',1.2);
% delay_int=0.267e-15*(1:length(delay));
NN=length(delay);
% for ii=1:NN-1
%     if delay(ii+1)==delay(ii);
%         delay(ii+1)=delay(ii+1)*1.000001;
%     end
% end
% delay_int=linspace(min(delay),max(delay),length(delay));
I_mod_int_45deg=interp1(delay,I_data,delay_int);
% hold on
% plot(delay_int*1e15,I_mod_int,'b','linewidth',1.2);

hold on
plot(0.456*(2000:-1:1010)-15,I_data,'k','linewidth',1.2);                 %Delay Calibration is necessary for MIR when using 2 meV voltage step, Without delay calibration, 4 meV is used.
xlabel('Delay (fs)');
ylabel('Modulation');
set(gca,'fontsize',20);


for j=1:10*length(delay_int)
    delay_int3(j)=delay_int(1)+(delay_int(2)-delay_int(1))*(j-1);
end
I_mod_int3(1:length(delay_int))=I_mod_int_45deg;
I_mod_int3(length(delay_int)+1:10*length(delay_int))=I_mod_int_45deg(length(I_mod_int_45deg));
figure();
plot(delay_int3*1e15,I_mod_int3,'b');
xlabel('Time (fs)');
ylabel('Intensity');

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);
freq_ret=linspace(-1/2/(delay_int(2)-delay_int(1)),(N/2-1)/N/(delay_int(2)-delay_int(1)),N);
phase_ret=atan2(imag(I_spec),real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3282)==min(abs(3e8./freq_ret*1e9-3282)));
wavelength_ret_1500=freq_ret(dd);
Phase_45deg = phase_ret(ff);
figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2800,3600]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum2(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Spectrum2(:,2) = (abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2,'r','linewidth',1.2);
xlim([2800,3800]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);

Phase2(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Phase2(:,2) = phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2;

I_data = II_mod(2010:3000);

delay=II_delay(2010:3000)*1e-15;

figure();
plot(delay*1e15,I_data,'r','linewidth',1.2);
% delay_int=0.267e-15*(1:length(delay));
NN=length(delay);
% for ii=1:NN-1
%     if delay(ii+1)==delay(ii);
%         delay(ii+1)=delay(ii+1)*1.000001;
%     end
% end
% delay_int=linspace(min(delay),max(delay),length(delay));
I_mod_int_P=interp1(delay,I_data,delay_int);
% hold on
% plot(delay_int*1e15,I_mod_int,'b','linewidth',1.2);

% hold on
% plot(0.456*(2100:2900)-15,I_data,'k','linewidth',1.2);                 %Delay Calibration is necessary for MIR when using 2 meV voltage step, Without delay calibration, 4 meV is used.
xlabel('Delay (fs)');
ylabel('Modulation');
set(gca,'fontsize',20);


for j=1:10*length(delay_int)
    delay_int3(j)=delay_int(1)+(delay_int(2)-delay_int(1))*(j-1);
end
I_mod_int3(1:length(delay_int))=I_mod_int_P;
I_mod_int3(length(delay_int)+1:10*length(delay_int))=I_mod_int_P(length(I_mod_int_P));
figure();
plot(delay_int3*1e15,I_mod_int3,'b');
xlabel('Time (fs)');
ylabel('Intensity');

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);
freq_ret=linspace(-1/2/(delay_int(2)-delay_int(1)),(N/2-1)/N/(delay_int(2)-delay_int(1)),N);
phase_ret=atan2(imag(I_spec),real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3282)==min(abs(3e8./freq_ret*1e9-3282)));
wavelength_ret_1500=freq_ret(dd);
Phase_P = phase_ret(ff);
figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2800,3600]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum3(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Spectrum3(:,2) = (abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2,'r','linewidth',1.2);
xlim([2800,3800]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);

Phase3(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Phase3(:,2) = phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2;

figure();
plot(Spectrum1(:,1),Spectrum1(:,2),'r','linewidth',1.2);
hold on
plot(Spectrum2(:,1),Spectrum2(:,2),'g','linewidth',1.2);
hold on
plot(Spectrum3(:,1),Spectrum3(:,2),'b','linewidth',1.2);
hold on
plot(Spectrum(:,3),Spectrum(:,4),'k--','linewidth',1.2);

II_MIR = importdata('3200nm_350d_NoLens_19.txt');
hold on
plot(II_MIR.data(:,2),(II_MIR.data(:,4)-7000)/((max(II_MIR.data(:,4))-7000))/0.6061/0.729,'k','linewidth',1.2);

xlim([2900,3700]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

figure();
plot(Phase1(:,1),Phase1(:,2),'r','linewidth',1.2);
hold on
plot(Phase2(:,1),Phase2(:,2),'g','linewidth',1.2);
hold on
plot(Phase3(:,1),Phase3(:,2),'b','linewidth',1.2);
hold on
plot(Phase(:,3),Phase(:,4),'k','linewidth',1.2);
xlim([2900,3700]);
% ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

figure();
plot(delay_int,I_mod_int_S,'r');
hold on
plot(delay_int,I_mod_int_45deg,'b');
hold on
plot(delay_int,I_mod_int_P,'k');
% close all;
% II_mod = importdata('Modd.txt');

Electric_59_64(:,1)=delay_int*1e15;
Electric_59_64(:,2)=I_mod_int_S;
Electric_59_64(:,3)=I_mod_int_P;
dlmwrite('Electric_59_64.txt',Electric_59_64,'delimiter','\t','precision',7);

II_mod = importdata('Pixel_77_64.txt');

I_data = II_mod(10:1000);

delay=II_delay(10:1000)*1e-15;

figure();
plot(delay*1e15,I_data,'r','linewidth',1.2);
% delay_int=0.267e-15*(1:length(delay));
NN=length(delay);
% for ii=1:NN-1
%     if delay(ii+1)==delay(ii);
%         delay(ii+1)=delay(ii+1)*1.000001;
%     end
% end
delay_int=linspace(70e-15,400e-15,800);
I_mod_int_S=interp1(delay,I_data,delay_int);
% hold on
% plot(delay_int*1e15,I_mod_int,'b','linewidth',1.2);

% hold on
% plot(0.456*(100:900)-15,I_data,'k','linewidth',1.2);                 %Delay Calibration is necessary for MIR when using 2 meV voltage step, Without delay calibration, 4 meV is used.
xlabel('Delay (fs)');
ylabel('Modulation');
set(gca,'fontsize',20);


for j=1:10*length(delay_int)
    delay_int3(j)=delay_int(1)+(delay_int(2)-delay_int(1))*(j-1);
end
I_mod_int3(1:length(delay_int))=I_mod_int_S;
I_mod_int3(length(delay_int)+1:10*length(delay_int))=I_mod_int_S(length(I_mod_int_S));
figure();
plot(delay_int3*1e15,I_mod_int3,'b');
xlabel('Time (fs)');
ylabel('Intensity');

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);
freq_ret=linspace(-1/2/(delay_int(2)-delay_int(1)),(N/2-1)/N/(delay_int(2)-delay_int(1)),N);
phase_ret=atan2(imag(I_spec),real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3282)==min(abs(3e8./freq_ret*1e9-3282)));
wavelength_ret_1500=freq_ret(dd);
Phase_S = phase_ret(ff);

figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2800,3600]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum1(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Spectrum1(:,2) = (abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2,'r','linewidth',1.2);
xlim([2800,3800]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);

Phase1(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Phase1(:,2) = phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2;

I_data = II_mod(2000:-1:1010);

delay=II_delay(2000:-1:1010)*1e-15;

figure();
plot(delay*1e15,I_data,'r','linewidth',1.2);
% delay_int=0.267e-15*(1:length(delay));
NN=length(delay);
% for ii=1:NN-1
%     if delay(ii+1)==delay(ii);
%         delay(ii+1)=delay(ii+1)*1.000001;
%     end
% end
% delay_int=linspace(min(delay),max(delay),length(delay));
I_mod_int_45deg=interp1(delay,I_data,delay_int);
% hold on
% plot(delay_int*1e15,I_mod_int,'b','linewidth',1.2);

hold on
plot(0.456*(2000:-1:1010)-15,I_data,'k','linewidth',1.2);                 %Delay Calibration is necessary for MIR when using 2 meV voltage step, Without delay calibration, 4 meV is used.
xlabel('Delay (fs)');
ylabel('Modulation');
set(gca,'fontsize',20);


for j=1:10*length(delay_int)
    delay_int3(j)=delay_int(1)+(delay_int(2)-delay_int(1))*(j-1);
end
I_mod_int3(1:length(delay_int))=I_mod_int_45deg;
I_mod_int3(length(delay_int)+1:10*length(delay_int))=I_mod_int_45deg(length(I_mod_int_45deg));
figure();
plot(delay_int3*1e15,I_mod_int3,'b');
xlabel('Time (fs)');
ylabel('Intensity');

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);
freq_ret=linspace(-1/2/(delay_int(2)-delay_int(1)),(N/2-1)/N/(delay_int(2)-delay_int(1)),N);
phase_ret=atan2(imag(I_spec),real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3282)==min(abs(3e8./freq_ret*1e9-3282)));
wavelength_ret_1500=freq_ret(dd);
Phase_45deg = phase_ret(ff);
figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2800,3600]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum2(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Spectrum2(:,2) = (abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2,'r','linewidth',1.2);
xlim([2800,3800]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);

Phase2(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Phase2(:,2) = phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2;

I_data = II_mod(2010:3000);

delay=II_delay(2010:3000)*1e-15;

figure();
plot(delay*1e15,I_data,'r','linewidth',1.2);
% delay_int=0.267e-15*(1:length(delay));
NN=length(delay);
% for ii=1:NN-1
%     if delay(ii+1)==delay(ii);
%         delay(ii+1)=delay(ii+1)*1.000001;
%     end
% end
% delay_int=linspace(min(delay),max(delay),length(delay));
I_mod_int_P=interp1(delay,I_data,delay_int);
% hold on
% plot(delay_int*1e15,I_mod_int,'b','linewidth',1.2);

% hold on
% plot(0.456*(2100:2900)-15,I_data,'k','linewidth',1.2);                 %Delay Calibration is necessary for MIR when using 2 meV voltage step, Without delay calibration, 4 meV is used.
xlabel('Delay (fs)');
ylabel('Modulation');
set(gca,'fontsize',20);


for j=1:10*length(delay_int)
    delay_int3(j)=delay_int(1)+(delay_int(2)-delay_int(1))*(j-1);
end
I_mod_int3(1:length(delay_int))=I_mod_int_P;
I_mod_int3(length(delay_int)+1:10*length(delay_int))=I_mod_int_P(length(I_mod_int_P));
figure();
plot(delay_int3*1e15,I_mod_int3,'b');
xlabel('Time (fs)');
ylabel('Intensity');

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);
freq_ret=linspace(-1/2/(delay_int(2)-delay_int(1)),(N/2-1)/N/(delay_int(2)-delay_int(1)),N);
phase_ret=atan2(imag(I_spec),real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3282)==min(abs(3e8./freq_ret*1e9-3282)));
wavelength_ret_1500=freq_ret(dd);
Phase_P = phase_ret(ff);
figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2800,3600]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum3(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Spectrum3(:,2) = (abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2,'r','linewidth',1.2);
xlim([2800,3800]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);

Phase3(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Phase3(:,2) = phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2;

figure();
plot(Spectrum1(:,1),Spectrum1(:,2),'r','linewidth',1.2);
hold on
plot(Spectrum2(:,1),Spectrum2(:,2),'g','linewidth',1.2);
hold on
plot(Spectrum3(:,1),Spectrum3(:,2),'b','linewidth',1.2);
hold on
plot(Spectrum(:,3),Spectrum(:,4),'k--','linewidth',1.2);

II_MIR = importdata('3200nm_350d_NoLens_19.txt');
hold on
plot(II_MIR.data(:,2),(II_MIR.data(:,4)-7000)/((max(II_MIR.data(:,4))-7000))/0.6061/0.729,'k','linewidth',1.2);

xlim([2900,3700]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

figure();
plot(Phase1(:,1),Phase1(:,2),'r','linewidth',1.2);
hold on
plot(Phase2(:,1),Phase2(:,2),'g','linewidth',1.2);
hold on
plot(Phase3(:,1),Phase3(:,2),'b','linewidth',1.2);
hold on
plot(Phase(:,3),Phase(:,4),'k','linewidth',1.2);
xlim([2900,3700]);
% ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

figure();
plot(delay_int,I_mod_int_S,'r');
hold on
plot(delay_int,I_mod_int_45deg,'b');
hold on
plot(delay_int,I_mod_int_P,'k');
% close all;
% II_mod = importdata('Modd.txt');

Electric_59_64(:,1)=delay_int*1e15;
Electric_59_64(:,2)=I_mod_int_S;
Electric_59_64(:,3)=I_mod_int_P;
dlmwrite('Electric_77_64.txt',Electric_59_64,'delimiter','\t','precision',7);

II_mod = importdata('Pixel_91_64.txt');

I_data = II_mod(10:1000);

delay=II_delay(10:1000)*1e-15;

figure();
plot(delay*1e15,I_data,'r','linewidth',1.2);
% delay_int=0.267e-15*(1:length(delay));
NN=length(delay);
% for ii=1:NN-1
%     if delay(ii+1)==delay(ii);
%         delay(ii+1)=delay(ii+1)*1.000001;
%     end
% end
delay_int=linspace(70e-15,400e-15,800);
I_mod_int_S=interp1(delay,I_data,delay_int);
% hold on
% plot(delay_int*1e15,I_mod_int,'b','linewidth',1.2);

% hold on
% plot(0.456*(100:900)-15,I_data,'k','linewidth',1.2);                 %Delay Calibration is necessary for MIR when using 2 meV voltage step, Without delay calibration, 4 meV is used.
xlabel('Delay (fs)');
ylabel('Modulation');
set(gca,'fontsize',20);


for j=1:10*length(delay_int)
    delay_int3(j)=delay_int(1)+(delay_int(2)-delay_int(1))*(j-1);
end
I_mod_int3(1:length(delay_int))=I_mod_int_S;
I_mod_int3(length(delay_int)+1:10*length(delay_int))=I_mod_int_S(length(I_mod_int_S));
figure();
plot(delay_int3*1e15,I_mod_int3,'b');
xlabel('Time (fs)');
ylabel('Intensity');

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);
freq_ret=linspace(-1/2/(delay_int(2)-delay_int(1)),(N/2-1)/N/(delay_int(2)-delay_int(1)),N);
phase_ret=atan2(imag(I_spec),real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3282)==min(abs(3e8./freq_ret*1e9-3282)));
wavelength_ret_1500=freq_ret(dd);
Phase_S = phase_ret(ff);

figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2800,3600]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum1(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Spectrum1(:,2) = (abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2,'r','linewidth',1.2);
xlim([2800,3800]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);

Phase1(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Phase1(:,2) = phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2;

I_data = II_mod(2000:-1:1010);

delay=II_delay(2000:-1:1010)*1e-15;

figure();
plot(delay*1e15,I_data,'r','linewidth',1.2);
% delay_int=0.267e-15*(1:length(delay));
NN=length(delay);
% for ii=1:NN-1
%     if delay(ii+1)==delay(ii);
%         delay(ii+1)=delay(ii+1)*1.000001;
%     end
% end
% delay_int=linspace(min(delay),max(delay),length(delay));
I_mod_int_45deg=interp1(delay,I_data,delay_int);
% hold on
% plot(delay_int*1e15,I_mod_int,'b','linewidth',1.2);

hold on
plot(0.456*(2000:-1:1010)-15,I_data,'k','linewidth',1.2);                 %Delay Calibration is necessary for MIR when using 2 meV voltage step, Without delay calibration, 4 meV is used.
xlabel('Delay (fs)');
ylabel('Modulation');
set(gca,'fontsize',20);


for j=1:10*length(delay_int)
    delay_int3(j)=delay_int(1)+(delay_int(2)-delay_int(1))*(j-1);
end
I_mod_int3(1:length(delay_int))=I_mod_int_45deg;
I_mod_int3(length(delay_int)+1:10*length(delay_int))=I_mod_int_45deg(length(I_mod_int_45deg));
figure();
plot(delay_int3*1e15,I_mod_int3,'b');
xlabel('Time (fs)');
ylabel('Intensity');

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);
freq_ret=linspace(-1/2/(delay_int(2)-delay_int(1)),(N/2-1)/N/(delay_int(2)-delay_int(1)),N);
phase_ret=atan2(imag(I_spec),real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3282)==min(abs(3e8./freq_ret*1e9-3282)));
wavelength_ret_1500=freq_ret(dd);
Phase_45deg = phase_ret(ff);
figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2800,3600]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum2(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Spectrum2(:,2) = (abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2,'r','linewidth',1.2);
xlim([2800,3800]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);

Phase2(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Phase2(:,2) = phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2;

I_data = II_mod(2010:3000);

delay=II_delay(2010:3000)*1e-15;

figure();
plot(delay*1e15,I_data,'r','linewidth',1.2);
% delay_int=0.267e-15*(1:length(delay));
NN=length(delay);
% for ii=1:NN-1
%     if delay(ii+1)==delay(ii);
%         delay(ii+1)=delay(ii+1)*1.000001;
%     end
% end
% delay_int=linspace(min(delay),max(delay),length(delay));
I_mod_int_P=interp1(delay,I_data,delay_int);
% hold on
% plot(delay_int*1e15,I_mod_int,'b','linewidth',1.2);

% hold on
% plot(0.456*(2100:2900)-15,I_data,'k','linewidth',1.2);                 %Delay Calibration is necessary for MIR when using 2 meV voltage step, Without delay calibration, 4 meV is used.
xlabel('Delay (fs)');
ylabel('Modulation');
set(gca,'fontsize',20);


for j=1:10*length(delay_int)
    delay_int3(j)=delay_int(1)+(delay_int(2)-delay_int(1))*(j-1);
end
I_mod_int3(1:length(delay_int))=I_mod_int_P;
I_mod_int3(length(delay_int)+1:10*length(delay_int))=I_mod_int_P(length(I_mod_int_P));
figure();
plot(delay_int3*1e15,I_mod_int3,'b');
xlabel('Time (fs)');
ylabel('Intensity');

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);
freq_ret=linspace(-1/2/(delay_int(2)-delay_int(1)),(N/2-1)/N/(delay_int(2)-delay_int(1)),N);
phase_ret=atan2(imag(I_spec),real(I_spec));

[aa,bb]=find(abs(3e8./freq_ret*1e9-1500)==min(abs(3e8./freq_ret*1e9-1500)));
wavelength_ret_600=freq_ret(bb);
[cc,dd]=find(abs(3e8./freq_ret*1e9-5000)==min(abs(3e8./freq_ret*1e9-5000)));
wavelength_ret_1500=freq_ret(dd);
[ee,ff]=find(abs(3e8./freq_ret*1e9-3282)==min(abs(3e8./freq_ret*1e9-3282)));
wavelength_ret_1500=freq_ret(dd);
Phase_P = phase_ret(ff);
figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2800,3600]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

Spectrum3(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Spectrum3(:,2) = (abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2,'r','linewidth',1.2);
xlim([2800,3800]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);

Phase3(:,1) = 3e8./freq_ret(dd:bb)*1e9;
Phase3(:,2) = phase_ret(dd:bb)+freq_ret(dd:bb)*1.3e-12-140+116.2;

figure();
plot(Spectrum1(:,1),Spectrum1(:,2),'r','linewidth',1.2);
hold on
plot(Spectrum2(:,1),Spectrum2(:,2),'g','linewidth',1.2);
hold on
plot(Spectrum3(:,1),Spectrum3(:,2),'b','linewidth',1.2);
hold on
plot(Spectrum(:,3),Spectrum(:,4),'k--','linewidth',1.2);

II_MIR = importdata('3200nm_350d_NoLens_19.txt');
hold on
plot(II_MIR.data(:,2),(II_MIR.data(:,4)-7000)/((max(II_MIR.data(:,4))-7000))/0.6061/0.729,'k','linewidth',1.2);

xlim([2900,3700]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

figure();
plot(Phase1(:,1),Phase1(:,2),'r','linewidth',1.2);
hold on
plot(Phase2(:,1),Phase2(:,2),'g','linewidth',1.2);
hold on
plot(Phase3(:,1),Phase3(:,2),'b','linewidth',1.2);
hold on
plot(Phase(:,3),Phase(:,4),'k','linewidth',1.2);
xlim([2900,3700]);
% ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

figure();
plot(delay_int,I_mod_int_S,'r');
hold on
plot(delay_int,I_mod_int_45deg,'b');
hold on
plot(delay_int,I_mod_int_P,'k');
% close all;
% II_mod = importdata('Modd.txt');

Electric_59_64(:,1)=delay_int*1e15;
Electric_59_64(:,2)=I_mod_int_S;
Electric_59_64(:,3)=I_mod_int_P;
dlmwrite('Electric_91_64.txt',Electric_59_64,'delimiter','\t','precision',7);


toc;