
clear
% clear;
% clc;
tic;
close all;

Wavelength_P = importdata('Wavelength_P.txt');
Wavelength_S = importdata('Wavelength_S.txt');

II_S1 = importdata('Phase_S.txt');
for i=1:78
    III=reshape(II_S1(i,:),120,120);
    II_S2(i,:,:) = III(:,:);                                %165 148
end
II_S(:,:) = sum(II_S2(25:27,:,:))/3;
II_S(:,:) = II_S2(24,:,:);
% % II_S(:,:) = II_S2(40,:,:);
% II_S(:,:) = II_S2(60,:,:);
% figure();
% imagesc(II_S);


II_P1 = importdata('Phase_P.txt');
for i=1:78
    III=reshape(II_P1(i,:),120,120);
    II_P2(i,:,:) = III(:,:);                                %165 148
end
II_P(:,:) = sum(II_P2(25:27,:,:))/3;
II_P(:,:) = II_P2(24,:,:);


% figure();
% imagesc(II_P);
% figure();
% imagesc(II_S-II_P);
% hold on
% X = [42 102];
% Y = [50 50]-7;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 102];
% Y = [105 105]-7;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 42];
% Y = [50 105]-7;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [102 102];
% Y = [50 105]-7;
% plot(X,Y,'k--','linewidth',1.2);

% hold on
% 
% rectangle('Position',[75-5,73-5,5*2,5*2],'curvature',[1,1]);
% axis equal;
% 
% xlim([0,140]);
% ylim([0,140]);
% set(gca,'fontsize',20);
% colorbar;


II_Sint = importdata('Intensity_S.txt');
% figure();
% imagesc(II_Sint);

II_Pint = importdata('Intensity_P.txt');
E_total = (II_Sint + II_Pint).^0.5;
E_max = max(max(E_total));
B = II_Sint.^0.5/E_max;
A = II_Pint.^0.5/E_max;


delta = -(II_S-II_P);
alfa = 0.5*atan2(2*A.*B.*cos(delta),(A.^2-B.^2));
E_a_max = (A.^2+B.^2).^0.5.*(A.^2.*(cos(alfa)).^2+B.^2.*(sin(alfa)).^2+A.*B.*cos(delta).*sin(2*alfa)).^0.5;

E_a_min = (A.^2+B.^2).^0.5.*(A.^2.*(sin(alfa)).^2+B.^2.*(cos(alfa)).^2-A.*B.*cos(delta).*sin(2*alfa)).^0.5;


E_ellipticity = E_a_min./E_a_max;

% figure();
% imagesc(E_ellipticity);
% caxis([0,1]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);

figure();
imagesc(E_total.^2/max(max(E_total.^2)));
caxis([0,1]);
xlabel('Pixel');
ylabel('Pixel');
set(gca,'fontsize',16);

Phase_Wave = II_S2-II_P2;
% Phase_Wave = Phase_Wave+pi;
Phase_Wave(33:45,:,:)=Phase_Wave(33:45,:,:)+2*pi;
Phase_Wave(14:20,:,:)=Phase_Wave(14:20,:,:)+2*pi;
Phase_Wave(59:65,:,:)=Phase_Wave(59:65,:,:)+2*pi;

%Dodge 1984
lambda = linspace(0.2,7.0,100000);
n_o = (1+0.48755108*lambda.^2./(lambda.^2-0.04338408^2)+0.39875031*lambda.^2./(lambda.^2-0.09461442^2)+2.3120353*lambda.^2./(lambda.^2-23.793604^2)).^0.5;
figure();
plot(lambda,n_o,'r','linewidth',1.2);


n_e = (1+0.41344023*lambda.^2./(lambda.^2-0.03684262^2)+0.50497499*lambda.^2./(lambda.^2-0.09076162^2)+2.4904862*lambda.^2./(lambda.^2-23.771995^2)).^0.5;
hold on
plot(lambda,n_e,'b','linewidth',1.2);
legend('n_o','n_e');
xlim([0,7]);
xlabel('Wavelength (um)');
ylabel('Refractive Index');
set(gca,'fontsize',20);

lambda0 = 3.28;
[aa,bb] = find(abs(lambda-lambda0)==min(abs(lambda-lambda0)));
n0_1 = n_o(bb);
n0_2 = n_e(bb);
Thickness = pi*lambda0*1e-6/2/pi/(n0_2-n0_1); 


c = 299792458;

lambda_wavelength = linspace(2.6,4,1000);
for ii =1:length(lambda_wavelength)
    [aa,bb] = find(abs(lambda-lambda_wavelength(ii))==min(abs(lambda-lambda_wavelength(ii))));
    n_o1 = n_o(bb);
    n_e1 = n_e(bb);
    Phase_difference(ii) = (Thickness/c*n_e1 -Thickness/c*n_o1)/(lambda_wavelength(ii)*1e-6/c)*2*pi;
end

% figure();
% plot(lambda_wavelength,Phase_difference,'r','linewidth',1.2);
% Phase = linspace(pi,pi,length(lambda_wavelength));
% hold on
% plot(lambda_wavelength,Phase,'b--','linewidth',1.2);
% xlabel('Wavelength (um)');
% ylabel('Phase retardation (rad)');
% legend('Phase difference between o and e (rad)','Phase difference pi at 3.28 um, HWP');
% set(gca,'fontsize',20);


figure();
plot(lambda_wavelength,Phase_difference/pi,'r','linewidth',1.2);
Phase = linspace(pi,pi,length(lambda_wavelength));
hold on
plot(lambda_wavelength,Phase/pi,'b--','linewidth',1.2);
xlabel('Wavelength (um)');
ylabel('Phase retardation (rad/pi)');
legend('Phase difference between o and e rays (rad/pi)','Phase difference pi at 3.28 um, HWP');
set(gca,'fontsize',20);

figure();
plot(Wavelength_P*1e6,Phase_Wave(:,37,66)+0,'r','linewidth',1.2);
hold on
plot(lambda_wavelength,Phase_difference/pi*pi,'g','linewidth',1.2);
hold on
plot(Wavelength_P*1e6,Phase_Wave(:,36,66)+0,'r--','linewidth',1.2);
hold on
plot(Wavelength_P*1e6,Phase_Wave(:,38,66)+0,'ro','linewidth',1.2);
hold on
plot(Wavelength_P*1e6,Phase_Wave(:,36,67)+0,'b','linewidth',1.2);
hold on
plot(Wavelength_P*1e6,Phase_Wave(:,37,67)+0,'b--','linewidth',1.2);
hold on
plot(Wavelength_P*1e6,Phase_Wave(:,38,67)+0,'bo','linewidth',1.2);
hold on
plot(Wavelength_P*1e6,Phase_Wave(:,36,68)+0,'k','linewidth',1.2);
hold on
plot(Wavelength_P*1e6,Phase_Wave(:,37,68)+0,'k--','linewidth',1.2);
hold on
plot(Wavelength_P*1e6,Phase_Wave(:,38,68)+0,'ko','linewidth',1.2);
ylim([0,6]);
set(gca,'fontsize',20);
xlabel('Wavelength (um)');
ylabel('Phase (rad)');

% III=reshape(II_S1(i,:),120,120);
%     II_S2(i,:,:) = III(:,:);  

I_SpectrumS = importdata('Spectrum_S.txt');
for ii=1:78
    Spectrum_S=reshape(I_SpectrumS(ii,:),120,120);
    II_SpectrumS(ii,:,:) = Spectrum_S(:,:);                                %165 148
    Mean_SpectrumS(ii) = sum(sum(II_SpectrumS(ii,33:42,60:69)))/100;
    Std_SpectrumS(ii) = (sum(sum((II_SpectrumS(ii,33:42,60:69)-Mean_SpectrumS(ii)).^2))/100).^0.5;
end

figure();
plot(Wavelength_P*1e6,Mean_SpectrumS,'r','linewidth',1.2);
hold on
errorbar(Wavelength_P*1e6,Mean_SpectrumS,Std_SpectrumS,'ro','linewidth',1.2);

Spectrum_S_Origin(:,1)=Wavelength_P*1e9;
Spectrum_S_Origin(:,2)=Mean_SpectrumS;
Spectrum_S_Origin(:,3)=Std_SpectrumS;
dlmwrite('Spectrum_S_Origin.txt',Spectrum_S_Origin,'delimiter','\t','precision',7);

ylim([0,1.05]);
xlim([2.4,3.8]);
set(gca,'fontsize',20);
xlabel('Wavelength (um)');
ylabel('Normalized Intensity');
box on


I_SpectrumP = importdata('Spectrum_P.txt');
for ii=1:78
    Spectrum_P=reshape(I_SpectrumP(ii,:),120,120);
    II_SpectrumP(ii,:,:) = Spectrum_P(:,:);                                %165 148
    Mean_SpectrumP(ii) = sum(sum(II_SpectrumP(ii,33:42,60:69)))/100;
    Std_SpectrumP(ii) = (sum(sum((II_SpectrumP(ii,33:42,60:69)-Mean_SpectrumP(ii)).^2))/100).^0.5;
end
hold on
plot(Wavelength_P*1e6,Mean_SpectrumP,'b','linewidth',1.2);
hold on
errorbar(Wavelength_P*1e6,Mean_SpectrumP,Std_SpectrumP,'bo','linewidth',1.2);

Spectrum_P_Origin(:,1)=Wavelength_P*1e9;
Spectrum_P_Origin(:,2)=Mean_SpectrumP;
Spectrum_P_Origin(:,3)=Std_SpectrumP;
dlmwrite('Spectrum_P_Origin.txt',Spectrum_P_Origin,'delimiter','\t','precision',7);
figure();
% hold on
% plot(lambda_wavelength,Phase_difference/pi*pi,'b','linewidth',5);

for ii=33:42
    for jj=60:69
        for kk=1:78
        if Phase_Wave(kk,ii,jj)<0
            Phase_Wave(kk,ii,jj)=Phase_Wave(kk,ii,jj)+2*pi;
        end
        if Phase_Wave(kk,ii,jj)>6
            Phase_Wave(kk,ii,jj)=Phase_Wave(kk,ii,jj)-2*pi;
        end
        end
            
        hold on
        plot(Wavelength_P*1e6,Phase_Wave(:,ii,jj)+0,'r','linewidth',1.2);
    end
end
hold on
plot(lambda_wavelength,Phase_difference/pi*pi,'b','linewidth',5);
ylim([2,5]);
xlim([2.4,3.8]);
set(gca,'fontsize',20);
xlabel('Wavelength (um)');
ylabel('Phase (rad)');

for ii=1:78
    
Mean_Phase(ii) = sum(sum(Phase_Wave(ii,33:42,60:69)))/100;
Std_Phase(ii) = (sum(sum((Phase_Wave(ii,33:42,60:69)-Mean_Phase(ii)).^2))/100).^0.5;
end

figure();
plot(Wavelength_P*1e6,Mean_Phase,'r','linewidth',1.2);
hold on
plot(lambda_wavelength,Phase_difference/pi*pi,'b','linewidth',3);
hold on
errorbar(Wavelength_P*1e6,Mean_Phase,Std_Phase,'ro','linewidth',1.2);
ylim([2,5]);
xlim([2.4,3.8]);
set(gca,'fontsize',20);
xlabel('Wavelength (um)');
ylabel('Phase (rad)');


[aaaa,bbbb]=find(abs(Wavelength_P-2.4e-6)==min(abs(Wavelength_P-2.4e-6)));
[cccc,dddd]=find(abs(Wavelength_P-3.9e-6)==min(abs(Wavelength_P-3.9e-6)));

Phase_refractive(:,1) = lambda_wavelength*1e3;
Phase_refractive(:,2) = Phase_difference/pi*pi;
dlmwrite('Phase_refractive.txt',Phase_refractive,'delimiter','\t','precision',7);

Phase_TIPTOE(:,1) = Wavelength_P(dddd:bbbb)*1e9;
Phase_TIPTOE(:,2) = Mean_Phase(dddd:bbbb);
Phase_TIPTOE(:,3) = Std_Phase(dddd:bbbb);
dlmwrite('Phase_TIPTOE.txt',Phase_TIPTOE,'delimiter','\t','precision',7);

figure();
% hold on
% plot(lambda_wavelength,Phase_difference/pi*pi,'b','linewidth',5);

for ii=33:42
    for jj=60:69
            
hold on
plot(Wavelength_P*1e6,II_SpectrumS(:,ii,jj),'r','linewidth',1.2);
hold on
plot(Wavelength_P*1e6,II_SpectrumP(:,ii,jj),'b','linewidth',1.2);
    end
end
% hold on
% plot(lambda_wavelength,Phase_difference/pi*pi,'b','linewidth',5);
ylim([0,1.05]);
xlim([2.4,3.8]);
set(gca,'fontsize',20);
xlabel('Wavelength (um)');
ylabel('Phase (rad)');
box on


II_Boson1 = importdata('Few_Cycle_Radial_Perturbation_3 - 20221123.jpeg');
II_Boson2 = importdata('Few_Cycle_Radial_Perturbation_8 - 20221123.jpeg');

II_Boson = double(II_Boson1(:,:,1)-II_Boson2(:,:,1)*0.8);
% figure();
% imagesc(II_Boson1(:,:,1));
% figure();
% imagesc(II_Boson2(:,:,2));
figure();
imagesc(II_Boson(251-58:251+58,364-58:364+58)/max(max(II_Boson(256-58:256+58,364-58:364+58))));
axis equal;

xxx=([-58:1:58])*6e-3-0.01;
yyy=([58:-1:-58])*6e-3+0.02;
[XX,YY]=meshgrid(xxx,yyy);
figure;
pcolor(XX,YY,(II_Boson(251-58:251+58,364-58:364+58)/max(max(II_Boson(256-58:256+58,364-58:364+58)))).^1.8);
% xlim([0.2,1.4]);
% ylim([0.2,1.4]);

shading interp
xlabel('x Position (mm)');
ylabel('y Position (mm)');
set(gca,'fontsize',20);

hold on
X = [0.25 0.58]-0.43;
Y = [0.52 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.58]-0.43;
Y = [0.20 0.20]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.25]-0.43;
Y = [0.20 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.58 0.58]-0.43;
Y = [0.2 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on

rectangle('Position',[-0.03,-0.03,0.03*2,0.03*2],'curvature',[1,1]);
axis equal;

xlim([-0.3,0.3]);
ylim([-0.3,0.3]);
set(gca,'fontsize',20);
colorbar;


Boson_Vector(1,1)=0;
Boson_Vector(1,2:length(xxx)+1)=xxx;
Boson_Vector(2:length(yyy)+1,1)=yyy';
Boson_Vector(2:length(yyy)+1,2:length(xxx)+1)=(II_Boson(251-58:251+58,364-58:364+58)/max(max(II_Boson(256-58:256+58,364-58:364+58)))).^1.8;
dlmwrite('Boson_Short_Vector.txt',Boson_Vector,'delimiter','\t','precision',7);
% axis equal;



% II_Boson1 = importdata('Few_Cycle_Radial_Perturbation_4 - 20221124.jpeg');
% II_Boson2 = importdata('Few_Cycle_Radial_Perturbation_5 - 20221124.jpeg');
% 
% II_Boson = double(II_Boson1(:,:,1)-II_Boson2(:,:,1));
% % figure();
% % imagesc(II_Boson1(:,:,1));
% figure();
% imagesc(II_Boson(256-58:256+58,350-58:350+58));
% axis equal;



xx=([0:1:119])*5.86e-3-0.3;
yy=([119:-1:0])*5.86e-3-0.39;
[X,Y]=meshgrid(xx,yy);
figure;
pcolor(X,Y,E_total.^2/max(max(E_total.^2)));
% xlim([0.2,1.4]);
% ylim([0.2,1.4]);

shading interp
xlabel('x Position (mm)');
ylabel('y Position (mm)');
set(gca,'fontsize',20);

hold on
X = [0.25 0.58]-0.43;
Y = [0.52 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.58]-0.43;
Y = [0.20 0.20]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.25 0.25]-0.43;
Y = [0.20 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on
X = [0.58 0.58]-0.43;
Y = [0.2 0.52]-0.35;
plot(X,Y,'k--','linewidth',1.2);

hold on

rectangle('Position',[-0.03,-0.03,0.03*2,0.03*2],'curvature',[1,1]);
axis equal;

xlim([-0.3,0.3]);
ylim([-0.3,0.3]);
set(gca,'fontsize',20);
colorbar;

TIPTOE_Vector(1,1)=0;
TIPTOE_Vector(1,2:length(xx)+1)=xx;
TIPTOE_Vector(2:length(yy)+1,1)=yy';
TIPTOE_Vector(2:length(yy)+1,2:length(xx)+1)=E_total.^2/max(max(E_total.^2));
dlmwrite('TIPTOE_Short_Vector.txt',TIPTOE_Vector,'delimiter','\t','precision',7);


















% figure();
% hold on
% plot(lambda_wavelength,Phase_difference/pi*pi,'b','linewidth',5);

% for ii=33:42
%     for jj=62:71
%         for kk=1:78
%         if Phase_Wave(kk,ii,jj)<0
%             Phase_Wave(kk,ii,jj)=Phase_Wave(kk,ii,jj)+2*pi;
%         end
%         if Phase_Wave(kk,ii,jj)>6
%             Phase_Wave(kk,ii,jj)=Phase_Wave(kk,ii,jj)-2*pi;
%         end
%         end
%             
%         hold on
%         plot(Wavelength_P*1e6,Phase_Wave(:,ii,jj)+0,'r','linewidth',1.2);
%     end
% end
% hold on
% plot(lambda_wavelength,Phase_difference/pi*pi,'b','linewidth',5);
% ylim([2,5]);
% xlim([2.4,3.8]);
% set(gca,'fontsize',20);
% xlabel('Wavelength (um)');
% ylabel('Phase (rad)');
% 
% figure();
% % hold on
% % plot(lambda_wavelength,Phase_difference/pi*pi,'b','linewidth',5);
% 
% for ii=33:42
%     for jj=63:72
%         for kk=1:78
%         if Phase_Wave(kk,ii,jj)<0
%             Phase_Wave(kk,ii,jj)=Phase_Wave(kk,ii,jj)+2*pi;
%         end
%         if Phase_Wave(kk,ii,jj)>6
%             Phase_Wave(kk,ii,jj)=Phase_Wave(kk,ii,jj)-2*pi;
%         end
%         end
%             
%         hold on
%         plot(Wavelength_P*1e6,Phase_Wave(:,ii,jj)+0,'r','linewidth',1.2);
%     end
% end
% hold on
% plot(lambda_wavelength,Phase_difference/pi*pi,'b','linewidth',5);
% ylim([2,5]);
% xlim([2.4,3.8]);
% set(gca,'fontsize',20);
% xlabel('Wavelength (um)');
% ylabel('Phase (rad)');






% figure();
% plot(Wavelength_P*1e6,II_SpectrumS(:,37,66)+0,'r','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumS(:,36,66)+0,'r','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumS(:,38,66)+0,'r','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumS(:,36,67)+0,'r','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumS(:,37,67)+0,'r','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumS(:,38,67)+0,'r','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumS(:,36,68)+0,'r','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumS(:,37,68)+0,'r','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumS(:,38,68)+0,'r','linewidth',1.2);
% ylim([0,1.05]);
% set(gca,'fontsize',20);
% xlabel('Wavelength (um)');
% ylabel('Phase (rad)');
% 
% hold on
% plot(Wavelength_P*1e6,II_SpectrumP(:,37,66)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumP(:,36,66)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumP(:,38,66)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumP(:,36,67)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumP(:,37,67)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumP(:,38,67)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumP(:,36,68)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumP(:,37,68)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,II_SpectrumP(:,38,68)+0,'b','linewidth',1.2);
% ylim([0,1.05]);
% set(gca,'fontsize',20);
% xlabel('Wavelength (um)');
% ylabel('Phase (rad)');
% 
% 
% figure();
% plot(Wavelength_P*1e6,Phase_Wave(:,37,63)+0,'r','linewidth',1.2);
% hold on
% plot(lambda_wavelength,Phase_difference/pi*pi,'g','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,63)+0,'r--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,63)+0,'ro','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,64)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,37,64)+0,'b--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,64)+0,'bo','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,65)+0,'k','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,37,65)+0,'k--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,65)+0,'ko','linewidth',1.2);
% ylim([0,6]);
% set(gca,'fontsize',20);
% xlabel('Wavelength (um)');
% ylabel('Phase (rad)');
% 
% figure();
% plot(Wavelength_P*1e6,Phase_Wave(:,37,60)+0,'r','linewidth',1.2);
% hold on
% plot(lambda_wavelength,Phase_difference/pi*pi,'g','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,60)+0,'r--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,60)+0,'ro','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,61)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,37,61)+0,'b--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,61)+0,'bo','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,62)+0,'k','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,37,62)+0,'k--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,62)+0,'ko','linewidth',1.2);
% ylim([0,6]);
% set(gca,'fontsize',20);
% xlabel('Wavelength (um)');
% ylabel('Phase (rad)');
% 
% 
% 
% figure();
% plot(Wavelength_P*1e6,Phase_Wave(:,37,69)+0,'r','linewidth',1.2);
% hold on
% plot(lambda_wavelength,Phase_difference/pi*pi,'g','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,69)+0,'r--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,69)+0,'ro','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,70)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,37,70)+0,'b--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,70)+0,'bo','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,71)+0,'k','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,37,71)+0,'k--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,71)+0,'ko','linewidth',1.2);
% ylim([0,6]);
% set(gca,'fontsize',20);
% xlabel('Wavelength (um)');
% ylabel('Phase (rad)');
% 
% 
% figure();
% plot(Wavelength_P*1e6,Phase_Wave(:,37,72)+0,'r','linewidth',1.2);
% hold on
% plot(lambda_wavelength,Phase_difference/pi*pi,'g','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,72)+0,'r--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,72)+0,'ro','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,73)+0,'b','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,37,73)+0,'b--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,73)+0,'bo','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,36,74)+0,'k','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,37,74)+0,'k--','linewidth',1.2);
% hold on
% plot(Wavelength_P*1e6,Phase_Wave(:,38,74)+0,'ko','linewidth',1.2);
% ylim([0,6]);
% set(gca,'fontsize',20);
% xlabel('Wavelength (um)');
% ylabel('Phase (rad)');









% figure();
% plot(Wavelength_P,Phase_Wave(:,64,85),'r','linewidth',1.2);
% ylim([0,8]);
% 
% 
% 
% figure();
% plot(Wavelength_P,Phase_Wave(:,58,91),'r','linewidth',1.2);
% ylim([0,8]);


% delta = -(II_S-II_P);
% 
% II_Sint = importdata('Intensity_S.txt');
% figure();
% imagesc(II_Sint);
% 
% II_Pint = importdata('Intensity_P.txt');
% figure();
% imagesc(II_Pint);
% 
% II_sgnS = importdata('Sgn_S.txt');
% II_sgnP = importdata('Sgn_P.txt');
% figure();
% imagesc(atan2(-II_Sint.*II_sgnS,-II_Pint.*II_sgnP));
% hold on
% X = [42 102];
% Y = [50 50]-7;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 102];
% Y = [105 105]-7;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 42];
% Y = [50 105]-7;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [102 102];
% Y = [50 105]-7;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% 
% rectangle('Position',[75-5,73-5,5*2,5*2],'curvature',[1,1]);
% axis equal;
% 
% xlim([0,140]);
% ylim([0,140]);
% set(gca,'fontsize',20);
% colorbar;
% 
% 
% 
% xx=([0:1:139])*5.86e-3-0.43;
% yy=([139:-1:0])*5.86e-3-0.35;
% [X,Y]=meshgrid(xx,yy);
% figure;
% pcolor(X,Y,atan2(-II_Sint.*II_sgnS,-II_Pint.*II_sgnP));
% % xlim([0.2,1.4]);
% % ylim([0.2,1.4]);
% 
% hold on
% X = [0.25 0.58]-0.43;
% Y = [0.52 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.25 0.58]-0.43;
% Y = [0.20 0.20]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.25 0.25]-0.43;
% Y = [0.20 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.58 0.58]-0.43;
% Y = [0.2 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% 
% rectangle('Position',[0.43-0.03-0.43,0.4-0.03-0.35,0.03*2,0.03*2],'curvature',[1,1]);
% axis equal;
% colorbar;
% shading interp
% xlabel('x Position (mm)');
% ylabel('y Position (mm)');
% set(gca,'fontsize',20);
% 
% Polarization(1,1)=0;
% Polarization(1,2:length(xx)+1)=xx;
% Polarization(2:length(yy)+1,1)=yy';
% Polarization(2:length(yy)+1,2:length(xx)+1)=atan2(-II_Sint.*II_sgnS,-II_Pint.*II_sgnP);
% dlmwrite('Polarization.txt',Polarization,'delimiter','\t','precision',7);
% 
% 
% 
% 
% E_total = (II_Sint + II_Pint).^0.5;
% E_max = max(max(E_total));
% E_total = E_total/max(max(E_total));
% figure();
% imagesc(E_total);
% 
% figure();
% imagesc(E_total.^2);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% hold on
% X = [42 102];
% Y = [50 50];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 102];
% Y = [105 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 42];
% Y = [50 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [102 102];
% Y = [50 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% 
% rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
% axis equal;
% 
% xlim([0,140]);
% ylim([0,140]);
% set(gca,'fontsize',20);
% colorbar;
% 
% 
% 
% 
% 
% 
% 
% xx=([0:1:139])*5.86e-3-0.43;
% yy=([139:-1:0])*5.86e-3-0.35;
% [X,Y]=meshgrid(xx,yy);
% figure;
% pcolor(X,Y,E_total.^2);
% % xlim([0.2,1.4]);
% % ylim([0.2,1.4]);
% 
% shading interp
% xlabel('x Position (mm)');
% ylabel('y Position (mm)');
% set(gca,'fontsize',20);
% 
% hold on
% X = [0.25 0.58]-0.43;
% Y = [0.52 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.25 0.58]-0.43;
% Y = [0.20 0.20]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.25 0.25]-0.43;
% Y = [0.20 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.58 0.58]-0.43;
% Y = [0.2 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% 
% rectangle('Position',[0.43-0.03-0.43,0.4-0.03-0.35,0.03*2,0.03*2],'curvature',[1,1]);
% axis equal;
% 
% % xlim([0,0.801]);
% % ylim([0,0.801]);
% set(gca,'fontsize',20);
% colorbar;
% 
% 
% 
% 
% 
% TIPTOE_Bessel(1,1)=0;
% TIPTOE_Bessel(1,2:length(xx)+1)=xx;
% TIPTOE_Bessel(2:length(yy)+1,1)=yy';
% TIPTOE_Bessel(2:length(yy)+1,2:length(xx)+1)=E_total.^2;
% dlmwrite('TIPTOE_Vector.txt',TIPTOE_Bessel,'delimiter','\t','precision',7);
% 
% 
% 
% 
% B = II_Sint.^0.5/E_max;
% A = II_Pint.^0.5/E_max;
% 
% % delta(:,:)=1;
% 
% alfa = 0.5*atan2(2*A.*B.*cos(delta),(A.^2-B.^2));
% figure();
% imagesc(alfa);
% 
% hold on
% X = [42 102];
% Y = [50 50];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 102];
% Y = [105 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 42];
% Y = [50 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [102 102];
% Y = [50 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% 
% rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
% axis equal;
% 
% xlim([0,140]);
% ylim([0,140]);
% set(gca,'fontsize',20);
% colorbar;
% 
% E_a_max = (A.^2+B.^2).^0.5.*(A.^2.*(cos(alfa)).^2+B.^2.*(sin(alfa)).^2+A.*B.*cos(delta).*sin(2*alfa)).^0.5;
% figure();
% imagesc(E_a_max);
% E_a_min = (A.^2+B.^2).^0.5.*(A.^2.*(sin(alfa)).^2+B.^2.*(cos(alfa)).^2-A.*B.*cos(delta).*sin(2*alfa)).^0.5;
% figure();
% imagesc(E_a_min);
% 
% E_ellipticity = E_a_min./E_a_max;
% % E_ellipticity = E_a_max./E_a_min;
% 
% figure();
% imagesc(E_ellipticity);
% caxis([0,1]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% 
% 
% hold on
% X = [42 102];
% Y = [50 50];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 102];
% Y = [105 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 42];
% Y = [50 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [102 102];
% Y = [50 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% 
% hold on
% 
% rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
% axis equal;
% 
% xlim([0,140]);
% ylim([0,140]);
% set(gca,'fontsize',20);
% colorbar;
% 
% 
% 
% 
% xx=([0:1:139])*5.86e-3-0.43;
% yy=([139:-1:0])*5.86e-3-0.35;
% [X,Y]=meshgrid(xx,yy);
% figure;
% pcolor(X,Y,E_ellipticity);
% % xlim([0.2,1.4]);
% % ylim([0.2,1.4]);
% 
% shading interp
% xlabel('x Position (mm)');
% ylabel('y Position (mm)');
% set(gca,'fontsize',20);
% 
% hold on
% X = [0.25 0.58]-0.43;
% Y = [0.52 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.25 0.58]-0.43;
% Y = [0.20 0.20]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.25 0.25]-0.43;
% Y = [0.20 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.58 0.58]-0.43;
% Y = [0.2 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% 
% rectangle('Position',[0.43-0.03-0.43,0.4-0.03-0.35,0.03*2,0.03*2],'curvature',[1,1]);
% axis equal;
% 
% % xlim([0,0.801]);
% % ylim([0,0.801]);
% set(gca,'fontsize',20);
% colorbar;
% 
% Ellipticity(1,1)=0;
% Ellipticity(1,2:length(xx)+1)=xx;
% Ellipticity(2:length(yy)+1,1)=yy';
% Ellipticity(2:length(yy)+1,2:length(xx)+1)=E_ellipticity;
% dlmwrite('Ellipticity.txt',Ellipticity,'delimiter','\t','precision',7);
% 
% 
% 
% 
% 
% figure();
% imagesc(E_ellipticity);
% caxis([0,0.3]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% 
% 
% hold on
% X = [42 102];
% Y = [50 50];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 102];
% Y = [105 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 42];
% Y = [50 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [102 102];
% Y = [50 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% 
% hold on
% 
% rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
% axis equal;
% 
% xlim([0,140]);
% ylim([0,140]);
% set(gca,'fontsize',20);
% colorbar;
% 
% 
% figure();
% imagesc(E_ellipticity);
% caxis([0,0.1]);
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% 
% 
% hold on
% X = [42 102];
% Y = [50 50];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 102];
% Y = [105 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [42 42];
% Y = [50 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [102 102];
% Y = [50 105];
% plot(X,Y,'k--','linewidth',1.2);
% 
% 
% hold on
% 
% rectangle('Position',[75-5,80-5,5*2,5*2],'curvature',[1,1]);
% axis equal;
% 
% xlim([0,140]);
% ylim([0,140]);
% set(gca,'fontsize',20);
% colorbar;
% 
% Int_Boson1 = importdata('Few_Cycle_Radial_Perturbation_4.jpeg');
% Int_Boson2 = importdata('Few_Cycle_Radial_Perturbation_8.jpeg');
% Int_MIR = double(Int_Boson1-Int_Boson2);
% figure();
% % imagesc((Int_MIR(:,:,1)));
% imagesc((Int_MIR(259-68:259+68,359-68:359+68,1))/max(max(Int_MIR(259-68:259+68,359-68:359+68,1))));
% xlabel('Pixel');
% ylabel('Pixel');
% set(gca,'fontsize',16);
% 
% 
% % xxx=([0:1:136])*6e-3-0.058;
% % yyy=([136:-1:0])*6e-3-0.03;
% xxx=([0:1:136])*6e-3+0.02-0.43;
% yyy=([136:-1:0])*6e-3-0.002-0.35;
% [X,Y]=meshgrid(xxx,yyy);
% figure;
% pcolor(X,Y,(Int_MIR(259-68:259+68,359-68:359+68,1))/max(max(Int_MIR(259-68:259+68,359-68:359+68,1))));
% % xlim([0,0.7]);
% % ylim([0,0.7]);
% 
% shading interp
% xlabel('x Position (mm)');
% ylabel('y Position (mm)');
% set(gca,'fontsize',20);
% 
% 
% hold on
% X = [0.25 0.58]-0.43;
% Y = [0.52 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.25 0.58]-0.43;
% Y = [0.20 0.20]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.25 0.25]-0.43;
% Y = [0.20 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% X = [0.58 0.58]-0.43;
% Y = [0.2 0.52]-0.3;
% plot(X,Y,'k--','linewidth',1.2);
% 
% hold on
% 
% rectangle('Position',[0.43-0.03-0.43,0.4-0.03-0.35,0.03*2,0.03*2],'curvature',[1,1]);
% axis equal;
% 
% % xlim([0,0.801]);
% % ylim([0,0.801]);
% set(gca,'fontsize',20);
% colorbar;
% % 
% % Boson_Vector(1,1)=0;
% % Boson_Vector(1,2:length(xxx)+1)=xxx;
% % Boson_Vector(2:length(yyy)+1,1)=yyy';
% % Boson_Vector(2:length(yyy)+1,2:length(xxx)+1)=(Int_MIR(273-68:273+68,315-68:315+68,1))/max(max(Int_MIR(273-68:273+68,315-68:315+68,1)));
% % dlmwrite('Boson_Vector.txt',Boson_Vector,'delimiter','\t','precision',7);
% % % axis equal;
% 























toc;