clear;
clc;
tic;
close all;
clear Spectrum;
clear Phase;

II=importdata('1_FundamentalLoop_120x120.txt');
x_length = 120;
y_length = 120;
[N,NN]=size(II); 

N=3606;
% delay_int=linspace(min(delay),max(delay),length(delay));
for i=1:N
    III=reshape(II(i,:),y_length,x_length);
    Pixel(i,:,:) = III(:,:);                                %165 148
end


II_delay = importdata('Delay1.txt');
delay = II_delay*1e-15;



delay_int=linspace(50e-15,210e-15,800);
Ds = delay_int(2)-delay_int(1);
c=299792458;

delay1 = delay(10:600);
delay2 = delay(610:1200);
delay3 = delay(1210:1800);

figure();
for ii=37
    jj=64
%     clear Mod1;
%     clear Mod2;
%     clear Mod3;
Mod1 = Pixel(10:600,ii,jj);
Mod2 = Pixel(610:1200,ii,jj);
Mod3 = Pixel(1210:1800,ii,jj);



I_mod_int1=interp1(delay1,Mod1,delay_int);
I_mod_int2=interp1(delay2,Mod2,delay_int);
I_mod_int3=interp1(delay3,Mod3,delay_int);
I_mod_intS = I_mod_int1 + I_mod_int2 + I_mod_int3;
% I_mod_intS(ii,:) = I_mod_int1 + I_mod_int2 + I_mod_int3;
hold on
plot(delay_int*1e15,I_mod_intS,'r','linewidth',1.2);

end


delay4 = delay(1810:2400);
delay5 = delay(2410:3000);
delay6 = delay(3010:3600);


for ii=37
    jj=64
Mod4 = Pixel(1810:2400,ii,jj);
Mod5 = Pixel(2410:3000,ii,jj);
Mod6 = Pixel(3010:3600,ii,jj);



I_mod_int1=interp1(delay4,Mod4,delay_int);
I_mod_int2=interp1(delay5,Mod5,delay_int);
I_mod_int3=interp1(delay6,Mod6,delay_int);
I_mod_intP = I_mod_int1 + I_mod_int2 + I_mod_int3;
hold on
plot(delay_int*1e15,I_mod_intP,'b','linewidth',1.2);

end
xlabel('Time (fs)');
ylabel('Modulation');
box on
set(gca,'fontsize',20);



I_mod_int = I_mod_intS;

 for j=1:10*length(I_mod_int)
        delay_int3(j)=0+(Ds)*(j-1);
 end
    I_mod_int3(1:length(I_mod_int))=I_mod_int;
I_mod_int3(length(I_mod_int)+1:10*length(I_mod_int))=I_mod_int(length(I_mod_int));
    I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);

freq_ret=linspace(-1/2/(Ds),(N/2-1)/N/(Ds),N);
phase_ret=atan2(imag(I_spec),real(I_spec));
[aa,bb]=find(abs(freq_ret-c/2000e-9)==min(abs(freq_ret-c/2000e-9)));
[cc,dd]=find(abs(freq_ret-c/4000e-9)==min(abs(freq_ret-c/4000e-9)));
% [eee,fff]=find(abs(freq_ret-c/3280e-9)==min(abs(freq_ret-c/3280e-9)));
figure();
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'r','linewidth',1.2);
xlim([2000,4000]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);
Spectrum(:,1)=3e8./freq_ret(dd:bb)*1e9;
Spectrum(:,2)=(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*0.6e-12-140+116.2-29,'r','linewidth',1.2);
xlim([2000,4000]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);
Phase(:,1)=3e8./freq_ret(dd:bb)*1e9;
Phase(:,2)=phase_ret(dd:bb)+freq_ret(dd:bb)*0.6e-12-140+116.2-29;

I_mod_int = I_mod_intP;

 for j=1:10*length(I_mod_int)
        delay_int3(j)=0+(Ds)*(j-1);
 end
    I_mod_int3(1:length(I_mod_int))=I_mod_int;
I_mod_int3(length(I_mod_int)+1:10*length(I_mod_int))=I_mod_int(length(I_mod_int));
    I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);

freq_ret=linspace(-1/2/(Ds),(N/2-1)/N/(Ds),N);
phase_ret=atan2(imag(I_spec),real(I_spec));
[aa,bb]=find(abs(freq_ret-c/2000e-9)==min(abs(freq_ret-c/2000e-9)));
[cc,dd]=find(abs(freq_ret-c/4000e-9)==min(abs(freq_ret-c/4000e-9)));
% [eee,fff]=find(abs(freq_ret-c/3280e-9)==min(abs(freq_ret-c/3280e-9)));
figure();
plot(Spectrum(:,1),Spectrum(:,2),'r','linewidth',1.2);
hold on
plot(3e8./freq_ret(dd:bb)*1e9,(abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2/max((abs(I_spec(dd:bb))).^2.*(freq_ret(dd:bb)).^2),'b','linewidth',1.2);
xlim([2000,4000]);
ylim([0,1.05]);
xlabel('Wavelength (nm)');
ylabel('Normalized Intensity');
set(gca,'fontsize',20);

for j=dd:bb
    for k=1:2000
    if phase_ret(j)<phase_ret(j+1)
        phase_ret(j+1)=phase_ret(j+1)-pi;
    end
    end
end

figure();
plot(Phase(:,1),Phase(:,2),'r','linewidth',1.2);
hold on
plot(3e8./freq_ret(dd:bb)*1e9,phase_ret(dd:bb)+freq_ret(dd:bb)*0.6e-12-140+116.2-29,'b','linewidth',1.2);
xlim([2000,4000]);
% ylim([-10,10]);
xlabel('Wavelength (nm)');
ylabel('Phase (rad)');
set(gca,'fontsize',20);



figure();
plot(3e8./freq_ret(dd:bb)*1e9,2*pi-1*(phase_ret(dd:bb)+freq_ret(dd:bb)*0.6e-12-140+116.2-29-(Phase(:,2))'),'r','linewidth',1.2);

%Dodge 1984
lambda = linspace(0.2,7.0,100000);
n_o = (1+0.48755108*lambda.^2./(lambda.^2-0.04338408^2)+0.39875031*lambda.^2./(lambda.^2-0.09461442^2)+2.3120353*lambda.^2./(lambda.^2-23.793604^2)).^0.5;
% figure();
% plot(lambda,n_o,'r','linewidth',1.2);


n_e = (1+0.41344023*lambda.^2./(lambda.^2-0.03684262^2)+0.50497499*lambda.^2./(lambda.^2-0.09076162^2)+2.4904862*lambda.^2./(lambda.^2-23.771995^2)).^0.5;
% hold on
% plot(lambda,n_e,'b','linewidth',1.2);
% legend('n_o','n_e');
% xlim([0,7]);
% xlabel('Wavelength (um)');
% ylabel('Refractive Index');
% set(gca,'fontsize',20);

lambda0 = 3.28;
[aa,bb] = find(abs(lambda-lambda0)==min(abs(lambda-lambda0)));
n0_1 = n_o(bb);
n0_2 = n_e(bb);
Thickness = pi*lambda0*1e-6/2/pi/(n0_2-n0_1); 


c = 299792458;

lambda_wavelength = linspace(2.6,4,1000);
for ii =1:length(lambda_wavelength)
    [aa,bb] = find(abs(lambda-lambda_wavelength(ii))==min(abs(lambda-lambda_wavelength(ii))));
    n_o1 = n_o(bb);
    n_e1 = n_e(bb);
    Phase_difference(ii) = (Thickness/c*n_e1 -Thickness/c*n_o1)/(lambda_wavelength(ii)*1e-6/c)*2*pi;
end

hold on
plot(lambda_wavelength*1e3,Phase_difference/pi*pi,'g','linewidth',1.2);
ylim([0,6]);




% Pixel1 = importdata('Electric_59_64.txt');
% figure();
% plot(Pixel1(:,1),Pixel1(:,2),'r','linewidth',1.2);
% hold on
% plot(Pixel1(:,1),Pixel1(:,3),'b','linewidth',1.2);
% 
% Ds = (Pixel1(2,1)-Pixel1(1,1))*1e-15;
figure();
plot(delay_int,I_mod_intS,'r','linewidth',1.2);
c=299792458;
Mod = I_mod_intS;
for j=1:10*length(Mod)
    delay_int3(j)=0+(Ds)*(j-1);
end
I_mod_int3(1:length(Mod))=Mod;
I_mod_int3(length(Mod)+1:10*length(Mod))=Mod(length(Mod));

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);

freq_ret=linspace(-1/2/(Ds),(N/2-1)/N/(Ds),N);
phase_ret=atan(imag(I_spec)./real(I_spec)); 
[aaa,bbb]=find(abs(freq_ret-c/2400e-9)==min(abs(freq_ret-c/2400e-9)));
[ccc,ddd]=find(abs(freq_ret-c/3900e-9)==min(abs(freq_ret-c/3900e-9)));
% clear freq_ret3;
% clear I_spec3; 
% %Modulation peak

freq_ret3=freq_ret(ceil(length(I_spec)/2)+1:length(I_spec));
phase_ret3=phase_ret(ceil(length(I_spec)/2)+1:length(I_spec));
[aa,bb]=find(abs(freq_ret3-c/2400e-9)==min(abs(freq_ret3-c/2400e-9)));
[cc,dd]=find(abs(freq_ret3-c/3900e-9)==min(abs(freq_ret3-c/3900e-9)));
I_spec2=I_spec(ceil(length(I_spec)/2)+1:length(I_spec));
I_spec3(1:length(freq_ret3))=0;
I_spec3(dd:bb)=I_spec2(dd:bb);
E_ret2 = (fftshift(ifft((I_spec3))));
dt=1/(max(freq_ret3)-min(freq_ret3));
NNN=length(E_ret2);
tt=(-NNN/2)*dt:dt:(NNN/2-1)*dt;
figure();
% plot(tt*1e15+min(Pixel1(:,1)),real(E_ret2)/2/152^0.85*3,'r');
plot(tt*1e15+min(delay_int)*1e15,real(E_ret2)/2/152^0.85*3/1.313,'r','linewidth',1.2);
% hold on
% plot(delay_int*1e15,(I_mod_intS-500)/(max(I_mod_intS)-500),'r--','linewidth',1.2);
xlim([0,250]);
xlabel('Time (fs)');
ylabel('Modulation');
box on
set(gca,'fontsize',20);

Efield_37_64(:,1)=tt*1e15+min(delay_int)*1e15-122.5;
Efield_37_64(:,2)=real(E_ret2)/2/152^0.85*3/1.313;

% figure();
% plot(delay_int,I_mod_intS,'r','linewidth',1.2);
c=299792458;
Mod = I_mod_intP;
for j=1:10*length(Mod)
    delay_int3(j)=0+(Ds)*(j-1);
end
I_mod_int3(1:length(Mod))=Mod;
I_mod_int3(length(Mod)+1:10*length(Mod))=Mod(length(Mod));

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);

freq_ret=linspace(-1/2/(Ds),(N/2-1)/N/(Ds),N);
phase_ret=atan(imag(I_spec)./real(I_spec)); 
[aaa,bbb]=find(abs(freq_ret-c/2400e-9)==min(abs(freq_ret-c/2400e-9)));
[ccc,ddd]=find(abs(freq_ret-c/3900e-9)==min(abs(freq_ret-c/3900e-9)));
% clear freq_ret3;
% clear I_spec3; 
% %Modulation peak

freq_ret3=freq_ret(ceil(length(I_spec)/2)+1:length(I_spec));
phase_ret3=phase_ret(ceil(length(I_spec)/2)+1:length(I_spec));
[aa,bb]=find(abs(freq_ret3-c/2400e-9)==min(abs(freq_ret3-c/2400e-9)));
[cc,dd]=find(abs(freq_ret3-c/3900e-9)==min(abs(freq_ret3-c/3900e-9)));
I_spec2=I_spec(ceil(length(I_spec)/2)+1:length(I_spec));
I_spec3(1:length(freq_ret3))=0;
I_spec3(dd:bb)=I_spec2(dd:bb);
E_ret2 = (fftshift(ifft((I_spec3))));
dt=1/(max(freq_ret3)-min(freq_ret3));
NNN=length(E_ret2);
tt=(-NNN/2)*dt:dt:(NNN/2-1)*dt;
hold on
% figure();
% plot(tt*1e15+min(Pixel1(:,1)),real(E_ret2)/2/152^0.85*3,'r');
plot(tt*1e15+min(delay_int)*1e15,real(E_ret2)/2/152^0.85*3/1.313,'b','linewidth',1.2);
% hold on
% plot(delay_int*1e15,(I_mod_intP-370)/(max(I_mod_intP)-370),'b--','linewidth',1.2);
xlim([0,250]);
% EField_59_64(:,1)=tt*1e15+min(Pixel1(:,1));
% EField_59_64(:,2)=real(E_ret2)/2/152^0.85*3;
xlabel('Time (fs)');
ylabel('Modulation');
box on
set(gca,'fontsize',20);
Efield_37_64(:,3)=real(E_ret2)/2/152^0.85*3/1.313;
dlmwrite('Efield_37_64.txt',Efield_37_64,'delimiter','\t','precision',7);


% figure();
% plot(Efield_37_64(:,1),Efield_37_64(:,2),'r');
% hold on
% plot(Efield_37_64(:,1),Efield_37_64(:,3),'b');


figure();
for ii=33
    jj=50
%     clear Mod1;
%     clear Mod2;
%     clear Mod3;
Mod1 = Pixel(10:600,ii,jj);
Mod2 = Pixel(610:1200,ii,jj);
Mod3 = Pixel(1210:1800,ii,jj);



I_mod_int1=interp1(delay1,Mod1,delay_int);
I_mod_int2=interp1(delay2,Mod2,delay_int);
I_mod_int3=interp1(delay3,Mod3,delay_int);
I_mod_intS = I_mod_int1 + I_mod_int2 + I_mod_int3;
% I_mod_intS(ii,:) = I_mod_int1 + I_mod_int2 + I_mod_int3;
hold on
plot(delay_int*1e15,I_mod_intS,'r','linewidth',1.2);

end


delay4 = delay(1810:2400);
delay5 = delay(2410:3000);
delay6 = delay(3010:3600);


for ii=33
    jj=50
Mod4 = Pixel(1810:2400,ii,jj);
Mod5 = Pixel(2410:3000,ii,jj);
Mod6 = Pixel(3010:3600,ii,jj);



I_mod_int1=interp1(delay4,Mod4,delay_int);
I_mod_int2=interp1(delay5,Mod5,delay_int);
I_mod_int3=interp1(delay6,Mod6,delay_int);
I_mod_intP = I_mod_int1 + I_mod_int2 + I_mod_int3;
hold on
plot(delay_int*1e15,I_mod_intP,'b','linewidth',1.2);

end
xlabel('Time (fs)');
ylabel('Modulation');
box on
set(gca,'fontsize',20);


figure();
plot(delay_int,I_mod_intS,'r','linewidth',1.2);
c=299792458;
Mod = I_mod_intS;
for j=1:10*length(Mod)
    delay_int3(j)=0+(Ds)*(j-1);
end
I_mod_int3(1:length(Mod))=Mod;
I_mod_int3(length(Mod)+1:10*length(Mod))=Mod(length(Mod));

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);

freq_ret=linspace(-1/2/(Ds),(N/2-1)/N/(Ds),N);
phase_ret=atan(imag(I_spec)./real(I_spec)); 
[aaa,bbb]=find(abs(freq_ret-c/2400e-9)==min(abs(freq_ret-c/2400e-9)));
[ccc,ddd]=find(abs(freq_ret-c/3900e-9)==min(abs(freq_ret-c/3900e-9)));
% clear freq_ret3;
% clear I_spec3; 
% %Modulation peak

freq_ret3=freq_ret(ceil(length(I_spec)/2)+1:length(I_spec));
phase_ret3=phase_ret(ceil(length(I_spec)/2)+1:length(I_spec));
[aa,bb]=find(abs(freq_ret3-c/2400e-9)==min(abs(freq_ret3-c/2400e-9)));
[cc,dd]=find(abs(freq_ret3-c/3900e-9)==min(abs(freq_ret3-c/3900e-9)));
I_spec2=I_spec(ceil(length(I_spec)/2)+1:length(I_spec));
I_spec3(1:length(freq_ret3))=0;
I_spec3(dd:bb)=I_spec2(dd:bb);
E_ret2 = (fftshift(ifft((I_spec3))));
dt=1/(max(freq_ret3)-min(freq_ret3));
NNN=length(E_ret2);
tt=(-NNN/2)*dt:dt:(NNN/2-1)*dt;
figure();
% plot(tt*1e15+min(Pixel1(:,1)),real(E_ret2)/2/152^0.85*3,'r');
plot(tt*1e15+min(delay_int)*1e15,real(E_ret2)/2/152^0.85*3/1.313,'r','linewidth',1.2);
% hold on
% plot(delay_int*1e15,(I_mod_intS-440)/(max(I_mod_intS)-440),'r--','linewidth',1.2);
xlim([0,250]);
xlabel('Time (fs)');
ylabel('Modulation');
box on
set(gca,'fontsize',20);

Efield_Pixel1(:,1)=tt*1e15+min(delay_int)*1e15;
Efield_Pixel1(:,2)=real(E_ret2)/2/152^0.85*3/1.313;

% figure();
% plot(delay_int,I_mod_intS,'r','linewidth',1.2);
c=299792458;
Mod = I_mod_intP;
for j=1:10*length(Mod)
    delay_int3(j)=0+(Ds)*(j-1);
end
I_mod_int3(1:length(Mod))=Mod;
I_mod_int3(length(Mod)+1:10*length(Mod))=Mod(length(Mod));

I_spec=fftshift(fft((I_mod_int3)));
N=length(I_spec);

freq_ret=linspace(-1/2/(Ds),(N/2-1)/N/(Ds),N);
phase_ret=atan(imag(I_spec)./real(I_spec)); 
[aaa,bbb]=find(abs(freq_ret-c/2400e-9)==min(abs(freq_ret-c/2400e-9)));
[ccc,ddd]=find(abs(freq_ret-c/3900e-9)==min(abs(freq_ret-c/3900e-9)));
% clear freq_ret3;
% clear I_spec3; 
% %Modulation peak

freq_ret3=freq_ret(ceil(length(I_spec)/2)+1:length(I_spec));
phase_ret3=phase_ret(ceil(length(I_spec)/2)+1:length(I_spec));
[aa,bb]=find(abs(freq_ret3-c/2400e-9)==min(abs(freq_ret3-c/2400e-9)));
[cc,dd]=find(abs(freq_ret3-c/3900e-9)==min(abs(freq_ret3-c/3900e-9)));
I_spec2=I_spec(ceil(length(I_spec)/2)+1:length(I_spec));
I_spec3(1:length(freq_ret3))=0;
I_spec3(dd:bb)=I_spec2(dd:bb);
E_ret2 = (fftshift(ifft((I_spec3))));
dt=1/(max(freq_ret3)-min(freq_ret3));
NNN=length(E_ret2);
tt=(-NNN/2)*dt:dt:(NNN/2-1)*dt;
hold on
% figure();
% plot(tt*1e15+min(Pixel1(:,1)),real(E_ret2)/2/152^0.85*3,'r');
plot(tt*1e15+min(delay_int)*1e15,real(E_ret2)/2/152^0.85*3/1.313,'b','linewidth',1.2);
% hold on
% plot(delay_int*1e15,(I_mod_intP-330)/(max(I_mod_intP)-330),'b--','linewidth',1.2);
xlim([0,250]);
% EField_59_64(:,1)=tt*1e15+min(Pixel1(:,1));
% EField_59_64(:,2)=real(E_ret2)/2/152^0.85*3;
xlabel('Time (fs)');
ylabel('Modulation');
box on
set(gca,'fontsize',20);



toc;